export declare const AddressToAddressWhiteList: {
    "contractName": string;
    "abi": ({
        "constant": boolean;
        "inputs": {
            "name": string;
            "type": string;
        }[];
        "name": string;
        "outputs": {
            "name": string;
            "type": string;
        }[];
        "payable": boolean;
        "stateMutability": string;
        "type": string;
        "anonymous"?: undefined;
    } | {
        "inputs": {
            "name": string;
            "type": string;
        }[];
        "payable": boolean;
        "stateMutability": string;
        "type": string;
        "constant"?: undefined;
        "name"?: undefined;
        "outputs"?: undefined;
        "anonymous"?: undefined;
    } | {
        "anonymous": boolean;
        "inputs": {
            "indexed": boolean;
            "name": string;
            "type": string;
        }[];
        "name": string;
        "type": string;
        "constant"?: undefined;
        "outputs"?: undefined;
        "payable"?: undefined;
        "stateMutability"?: undefined;
    })[];
    "metadata": string;
    "bytecode": string;
    "deployedBytecode": string;
    "sourceMap": string;
    "deployedSourceMap": string;
    "source": string;
    "sourcePath": string;
    "compiler": {
        "name": string;
        "version": string;
    };
    "networks": {};
    "schemaVersion": string;
    "updatedAt": string;
    "devdoc": {
        "author": string;
        "methods": {
            "addPair(address,address)": {
                "params": {
                    "_key": string;
                    "_value": string;
                };
            };
            "areValidAddresses(address[])": {
                "params": {
                    "_keys": string;
                };
                "return": string;
            };
            "constructor": {
                "params": {
                    "_initialKeys": string;
                    "_initialValues": string;
                };
            };
            "editPair(address,address)": {
                "params": {
                    "_key": string;
                    "_value": string;
                };
            };
            "getValue(address)": {
                "params": {
                    "_key": string;
                };
                "return": string;
            };
            "getValues(address[])": {
                "params": {
                    "_key": string;
                };
                "return": string;
            };
            "isOwner()": {
                "return": string;
            };
            "owner()": {
                "return": string;
            };
            "removePair(address)": {
                "params": {
                    "_key": string;
                };
            };
            "removeRegisteredUpgrade(bytes32)": {
                "params": {
                    "_upgradeHash": string;
                };
            };
            "renounceOwnership()": {
                "details": string;
            };
            "setTimeLockPeriod(uint256)": {
                "params": {
                    "_timeLockPeriod": string;
                };
            };
            "transferOwnership(address)": {
                "details": string;
                "params": {
                    "newOwner": string;
                };
            };
            "validAddresses()": {
                "return": string;
            };
        };
        "title": string;
    };
    "userdoc": {
        "methods": {
            "addPair(address,address)": {
                "notice": string;
            };
            "areValidAddresses(address[])": {
                "notice": string;
            };
            "constructor": string;
            "editPair(address,address)": {
                "notice": string;
            };
            "getValue(address)": {
                "notice": string;
            };
            "getValues(address[])": {
                "notice": string;
            };
            "removePair(address)": {
                "notice": string;
            };
            "removeRegisteredUpgrade(bytes32)": {
                "notice": string;
            };
            "renounceOwnership()": {
                "notice": string;
            };
            "setTimeLockPeriod(uint256)": {
                "notice": string;
            };
            "validAddresses()": {
                "notice": string;
            };
        };
    };
};
