export declare const Authorizable: {
    "contractName": string;
    "abi": ({
        "constant": boolean;
        "inputs": {
            "name": string;
            "type": string;
        }[];
        "name": string;
        "outputs": {
            "name": string;
            "type": string;
        }[];
        "payable": boolean;
        "stateMutability": string;
        "type": string;
        "anonymous"?: undefined;
    } | {
        "anonymous": boolean;
        "inputs": {
            "indexed": boolean;
            "name": string;
            "type": string;
        }[];
        "name": string;
        "type": string;
        "constant"?: undefined;
        "outputs"?: undefined;
        "payable"?: undefined;
        "stateMutability"?: undefined;
    })[];
    "metadata": string;
    "bytecode": string;
    "deployedBytecode": string;
    "sourceMap": string;
    "deployedSourceMap": string;
    "source": string;
    "sourcePath": string;
    "compiler": {
        "name": string;
        "version": string;
    };
    "networks": {};
    "schemaVersion": string;
    "updatedAt": string;
    "devdoc": {
        "author": string;
        "methods": {
            "addAuthorizedAddress(address)": {
                "params": {
                    "_authTarget": string;
                };
            };
            "getAuthorizedAddresses()": {
                "return": string;
            };
            "isOwner()": {
                "return": string;
            };
            "owner()": {
                "return": string;
            };
            "removeAuthorizedAddress(address)": {
                "params": {
                    "_authTarget": string;
                };
            };
            "renounceOwnership()": {
                "details": string;
            };
            "setTimeLockPeriod(uint256)": {
                "params": {
                    "_timeLockPeriod": string;
                };
            };
            "transferOwnership(address)": {
                "details": string;
                "params": {
                    "newOwner": string;
                };
            };
        };
        "title": string;
    };
    "userdoc": {
        "methods": {
            "addAuthorizedAddress(address)": {
                "notice": string;
            };
            "getAuthorizedAddresses()": {
                "notice": string;
            };
            "removeAuthorizedAddress(address)": {
                "notice": string;
            };
            "renounceOwnership()": {
                "notice": string;
            };
            "setTimeLockPeriod(uint256)": {
                "notice": string;
            };
        };
    };
};
