export declare const Core: {
    "contractName": string;
    "abi": ({
        "constant": boolean;
        "inputs": {
            "name": string;
            "type": string;
        }[];
        "name": string;
        "outputs": {
            "name": string;
            "type": string;
        }[];
        "payable": boolean;
        "stateMutability": string;
        "type": string;
        "anonymous"?: undefined;
    } | {
        "inputs": {
            "name": string;
            "type": string;
        }[];
        "payable": boolean;
        "stateMutability": string;
        "type": string;
        "constant"?: undefined;
        "name"?: undefined;
        "outputs"?: undefined;
        "anonymous"?: undefined;
    } | {
        "anonymous": boolean;
        "inputs": {
            "indexed": boolean;
            "name": string;
            "type": string;
        }[];
        "name": string;
        "type": string;
        "constant"?: undefined;
        "outputs"?: undefined;
        "payable"?: undefined;
        "stateMutability"?: undefined;
    })[];
    "metadata": string;
    "bytecode": string;
    "deployedBytecode": string;
    "sourceMap": string;
    "deployedSourceMap": string;
    "source": string;
    "sourcePath": string;
    "compiler": {
        "name": string;
        "version": string;
    };
    "networks": {};
    "schemaVersion": string;
    "updatedAt": string;
    "devdoc": {
        "author": string;
        "methods": {
            "addExchange(uint8,address)": {
                "params": {
                    "_exchange": string;
                    "_exchangeId": string;
                };
            };
            "addFactory(address)": {
                "params": {
                    "_factory": string;
                };
            };
            "addModule(address)": {
                "params": {
                    "_module": string;
                };
            };
            "addPriceLibrary(address)": {
                "params": {
                    "_priceLibrary": string;
                };
            };
            "batchDecrementTokenOwnerModule(address[],address,uint256[])": {
                "params": {
                    "_owner": string;
                    "_quantities": string;
                    "_tokens": string;
                };
            };
            "batchDeposit(address[],uint256[])": {
                "params": {
                    "_quantities": string;
                    "_tokens": string;
                };
            };
            "batchDepositModule(address,address,address[],uint256[])": {
                "params": {
                    "_from": string;
                    "_quantities": string;
                    "_to": string;
                    "_tokens": string;
                };
            };
            "batchIncrementTokenOwnerModule(address[],address,uint256[])": {
                "params": {
                    "_owner": string;
                    "_quantities": string;
                    "_tokens": string;
                };
            };
            "batchTransferBalanceModule(address[],address,address,uint256[])": {
                "params": {
                    "_from": string;
                    "_quantities": string;
                    "_to": string;
                    "_tokens": string;
                };
            };
            "batchTransferModule(address[],uint256[],address,address)": {
                "params": {
                    "_from": string;
                    "_quantities": string;
                    "_to": string;
                    "_tokens": string;
                };
            };
            "batchWithdraw(address[],uint256[])": {
                "params": {
                    "_quantities": string;
                    "_tokens": string;
                };
            };
            "batchWithdrawModule(address,address,address[],uint256[])": {
                "params": {
                    "_from": string;
                    "_quantities": string;
                    "_to": string;
                    "_tokens": string;
                };
            };
            "constructor": {
                "params": {
                    "_transferProxy": string;
                    "_vault": string;
                };
            };
            "createSet(address,address[],uint256[],uint256,bytes32,bytes32,bytes)": {
                "params": {
                    "_callData": string;
                    "_components": string;
                    "_factory": string;
                    "_name": string;
                    "_naturalUnit": string;
                    "_symbol": string;
                    "_units": string;
                };
                "return": string;
            };
            "deposit(address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_token": string;
                };
            };
            "depositModule(address,address,address,uint256)": {
                "params": {
                    "_from": string;
                    "_quantity": string;
                    "_to": string;
                    "_token": string;
                };
            };
            "disableSet(address)": {
                "params": {
                    "_set": string;
                };
            };
            "disabledSets(address)": {
                "params": {
                    "_set": string;
                };
                "return": string;
            };
            "exchangeIds(uint8)": {
                "params": {
                    "_exchangeId": string;
                };
                "return": string;
            };
            "exchanges()": {
                "return": string;
            };
            "factories()": {
                "return": string;
            };
            "internalTransfer(address,address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_to": string;
                    "_token": string;
                };
            };
            "isOwner()": {
                "return": string;
            };
            "issue(address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_set": string;
                };
            };
            "issueInVault(address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_set": string;
                };
            };
            "issueInVaultModule(address,address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_recipient": string;
                    "_set": string;
                };
            };
            "issueModule(address,address,address,uint256)": {
                "params": {
                    "_componentOwner": string;
                    "_quantity": string;
                    "_set": string;
                    "_setRecipient": string;
                };
            };
            "issueTo(address,address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_recipient": string;
                    "_set": string;
                };
            };
            "modules()": {
                "return": string;
            };
            "operationState()": {
                "return": string;
            };
            "owner()": {
                "return": string;
            };
            "priceLibraries()": {
                "return": string;
            };
            "redeem(address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_set": string;
                };
            };
            "redeemAndWithdrawTo(address,address,uint256,uint256)": {
                "params": {
                    "_quantity": string;
                    "_set": string;
                    "_to": string;
                    "_toExclude": string;
                };
            };
            "redeemInVault(address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_set": string;
                };
            };
            "redeemModule(address,address,address,uint256)": {
                "params": {
                    "_burnAddress": string;
                    "_incrementAddress": string;
                    "_quantity": string;
                    "_set": string;
                };
            };
            "redeemTo(address,address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_recipient": string;
                    "_set": string;
                };
            };
            "reenableSet(address)": {
                "params": {
                    "_set": string;
                };
            };
            "removeExchange(uint8,address)": {
                "params": {
                    "_exchange": string;
                    "_exchangeId": string;
                };
            };
            "removeFactory(address)": {
                "params": {
                    "_factory": string;
                };
            };
            "removeModule(address)": {
                "params": {
                    "_module": string;
                };
            };
            "removePriceLibrary(address)": {
                "params": {
                    "_priceLibrary": string;
                };
            };
            "renounceOwnership()": {
                "details": string;
            };
            "setOperationState(uint8)": {
                "params": {
                    "_operationState": string;
                };
            };
            "setTimeLockPeriod(uint256)": {
                "params": {
                    "_timeLockPeriod": string;
                };
            };
            "setTokens()": {
                "return": string;
            };
            "transferModule(address,uint256,address,address)": {
                "params": {
                    "_from": string;
                    "_quantity": string;
                    "_to": string;
                    "_token": string;
                };
            };
            "transferOwnership(address)": {
                "details": string;
                "params": {
                    "newOwner": string;
                };
            };
            "transferProxy()": {
                "return": string;
            };
            "validFactories(address)": {
                "params": {
                    "_factory": string;
                };
                "return": string;
            };
            "validModules(address)": {
                "params": {
                    "_module": string;
                };
                "return": string;
            };
            "validPriceLibraries(address)": {
                "params": {
                    "_priceLibrary": string;
                };
                "return": string;
            };
            "validSets(address)": {
                "params": {
                    "_set": string;
                };
                "return": string;
            };
            "vault()": {
                "return": string;
            };
            "withdraw(address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_token": string;
                };
            };
            "withdrawModule(address,address,address,uint256)": {
                "params": {
                    "_from": string;
                    "_quantity": string;
                    "_to": string;
                    "_token": string;
                };
            };
        };
        "title": string;
    };
    "userdoc": {
        "methods": {
            "addExchange(uint8,address)": {
                "notice": string;
            };
            "addFactory(address)": {
                "notice": string;
            };
            "addModule(address)": {
                "notice": string;
            };
            "addPriceLibrary(address)": {
                "notice": string;
            };
            "batchDecrementTokenOwnerModule(address[],address,uint256[])": {
                "notice": string;
            };
            "batchDeposit(address[],uint256[])": {
                "notice": string;
            };
            "batchDepositModule(address,address,address[],uint256[])": {
                "notice": string;
            };
            "batchIncrementTokenOwnerModule(address[],address,uint256[])": {
                "notice": string;
            };
            "batchTransferBalanceModule(address[],address,address,uint256[])": {
                "notice": string;
            };
            "batchTransferModule(address[],uint256[],address,address)": {
                "notice": string;
            };
            "batchWithdraw(address[],uint256[])": {
                "notice": string;
            };
            "batchWithdrawModule(address,address,address[],uint256[])": {
                "notice": string;
            };
            "constructor": string;
            "createSet(address,address[],uint256[],uint256,bytes32,bytes32,bytes)": {
                "notice": string;
            };
            "deposit(address,uint256)": {
                "notice": string;
            };
            "depositModule(address,address,address,uint256)": {
                "notice": string;
            };
            "disableSet(address)": {
                "notice": string;
            };
            "disabledSets(address)": {
                "notice": string;
            };
            "exchangeIds(uint8)": {
                "notice": string;
            };
            "exchanges()": {
                "notice": string;
            };
            "factories()": {
                "notice": string;
            };
            "internalTransfer(address,address,uint256)": {
                "notice": string;
            };
            "issue(address,uint256)": {
                "notice": string;
            };
            "issueInVault(address,uint256)": {
                "notice": string;
            };
            "issueInVaultModule(address,address,uint256)": {
                "notice": string;
            };
            "issueModule(address,address,address,uint256)": {
                "notice": string;
            };
            "issueTo(address,address,uint256)": {
                "notice": string;
            };
            "modules()": {
                "notice": string;
            };
            "operationState()": {
                "notice": string;
            };
            "priceLibraries()": {
                "notice": string;
            };
            "redeem(address,uint256)": {
                "notice": string;
            };
            "redeemAndWithdrawTo(address,address,uint256,uint256)": {
                "notice": string;
            };
            "redeemInVault(address,uint256)": {
                "notice": string;
            };
            "redeemModule(address,address,address,uint256)": {
                "notice": string;
            };
            "redeemTo(address,address,uint256)": {
                "notice": string;
            };
            "reenableSet(address)": {
                "notice": string;
            };
            "removeExchange(uint8,address)": {
                "notice": string;
            };
            "removeFactory(address)": {
                "notice": string;
            };
            "removeModule(address)": {
                "notice": string;
            };
            "removePriceLibrary(address)": {
                "notice": string;
            };
            "renounceOwnership()": {
                "notice": string;
            };
            "setOperationState(uint8)": {
                "notice": string;
            };
            "setTimeLockPeriod(uint256)": {
                "notice": string;
            };
            "setTokens()": {
                "notice": string;
            };
            "transferModule(address,uint256,address,address)": {
                "notice": string;
            };
            "transferProxy()": {
                "notice": string;
            };
            "validFactories(address)": {
                "notice": string;
            };
            "validModules(address)": {
                "notice": string;
            };
            "validPriceLibraries(address)": {
                "notice": string;
            };
            "validSets(address)": {
                "notice": string;
            };
            "vault()": {
                "notice": string;
            };
            "withdraw(address,uint256)": {
                "notice": string;
            };
            "withdrawModule(address,address,address,uint256)": {
                "notice": string;
            };
        };
    };
};
