export declare const CoreAccounting: {
    "contractName": string;
    "abi": ({
        "constant": boolean;
        "inputs": {
            "name": string;
            "type": string;
        }[];
        "name": string;
        "outputs": {
            "name": string;
            "type": string;
        }[];
        "payable": boolean;
        "stateMutability": string;
        "type": string;
        "anonymous"?: undefined;
    } | {
        "anonymous": boolean;
        "inputs": {
            "indexed": boolean;
            "name": string;
            "type": string;
        }[];
        "name": string;
        "type": string;
        "constant"?: undefined;
        "outputs"?: undefined;
        "payable"?: undefined;
        "stateMutability"?: undefined;
    })[];
    "metadata": string;
    "bytecode": string;
    "deployedBytecode": string;
    "sourceMap": string;
    "deployedSourceMap": string;
    "source": string;
    "sourcePath": string;
    "compiler": {
        "name": string;
        "version": string;
    };
    "networks": {};
    "schemaVersion": string;
    "updatedAt": string;
    "devdoc": {
        "author": string;
        "methods": {
            "batchDeposit(address[],uint256[])": {
                "params": {
                    "_quantities": string;
                    "_tokens": string;
                };
            };
            "batchWithdraw(address[],uint256[])": {
                "params": {
                    "_quantities": string;
                    "_tokens": string;
                };
            };
            "deposit(address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_token": string;
                };
            };
            "disabledSets(address)": {
                "params": {
                    "_set": string;
                };
                "return": string;
            };
            "exchangeIds(uint8)": {
                "params": {
                    "_exchangeId": string;
                };
                "return": string;
            };
            "exchanges()": {
                "return": string;
            };
            "factories()": {
                "return": string;
            };
            "internalTransfer(address,address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_to": string;
                    "_token": string;
                };
            };
            "isOwner()": {
                "return": string;
            };
            "modules()": {
                "return": string;
            };
            "operationState()": {
                "return": string;
            };
            "owner()": {
                "return": string;
            };
            "priceLibraries()": {
                "return": string;
            };
            "renounceOwnership()": {
                "details": string;
            };
            "setOperationState(uint8)": {
                "params": {
                    "_operationState": string;
                };
            };
            "setTokens()": {
                "return": string;
            };
            "transferOwnership(address)": {
                "details": string;
                "params": {
                    "newOwner": string;
                };
            };
            "transferProxy()": {
                "return": string;
            };
            "validFactories(address)": {
                "params": {
                    "_factory": string;
                };
                "return": string;
            };
            "validModules(address)": {
                "params": {
                    "_module": string;
                };
                "return": string;
            };
            "validPriceLibraries(address)": {
                "params": {
                    "_priceLibrary": string;
                };
                "return": string;
            };
            "validSets(address)": {
                "params": {
                    "_set": string;
                };
                "return": string;
            };
            "vault()": {
                "return": string;
            };
            "withdraw(address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_token": string;
                };
            };
        };
        "title": string;
    };
    "userdoc": {
        "methods": {
            "batchDeposit(address[],uint256[])": {
                "notice": string;
            };
            "batchWithdraw(address[],uint256[])": {
                "notice": string;
            };
            "deposit(address,uint256)": {
                "notice": string;
            };
            "disabledSets(address)": {
                "notice": string;
            };
            "exchangeIds(uint8)": {
                "notice": string;
            };
            "exchanges()": {
                "notice": string;
            };
            "factories()": {
                "notice": string;
            };
            "internalTransfer(address,address,uint256)": {
                "notice": string;
            };
            "modules()": {
                "notice": string;
            };
            "operationState()": {
                "notice": string;
            };
            "priceLibraries()": {
                "notice": string;
            };
            "renounceOwnership()": {
                "notice": string;
            };
            "setOperationState(uint8)": {
                "notice": string;
            };
            "setTokens()": {
                "notice": string;
            };
            "transferProxy()": {
                "notice": string;
            };
            "validFactories(address)": {
                "notice": string;
            };
            "validModules(address)": {
                "notice": string;
            };
            "validPriceLibraries(address)": {
                "notice": string;
            };
            "validSets(address)": {
                "notice": string;
            };
            "vault()": {
                "notice": string;
            };
            "withdraw(address,uint256)": {
                "notice": string;
            };
        };
    };
};
