export declare const CoreAdmin: {
    "contractName": string;
    "abi": ({
        "constant": boolean;
        "inputs": {
            "name": string;
            "type": string;
        }[];
        "name": string;
        "outputs": {
            "name": string;
            "type": string;
        }[];
        "payable": boolean;
        "stateMutability": string;
        "type": string;
        "anonymous"?: undefined;
    } | {
        "anonymous": boolean;
        "inputs": {
            "indexed": boolean;
            "name": string;
            "type": string;
        }[];
        "name": string;
        "type": string;
        "constant"?: undefined;
        "outputs"?: undefined;
        "payable"?: undefined;
        "stateMutability"?: undefined;
    })[];
    "metadata": string;
    "bytecode": string;
    "deployedBytecode": string;
    "sourceMap": string;
    "deployedSourceMap": string;
    "source": string;
    "sourcePath": string;
    "compiler": {
        "name": string;
        "version": string;
    };
    "networks": {};
    "schemaVersion": string;
    "updatedAt": string;
    "devdoc": {
        "author": string;
        "methods": {
            "addExchange(uint8,address)": {
                "params": {
                    "_exchange": string;
                    "_exchangeId": string;
                };
            };
            "addFactory(address)": {
                "params": {
                    "_factory": string;
                };
            };
            "addModule(address)": {
                "params": {
                    "_module": string;
                };
            };
            "addPriceLibrary(address)": {
                "params": {
                    "_priceLibrary": string;
                };
            };
            "disableSet(address)": {
                "params": {
                    "_set": string;
                };
            };
            "disabledSets(address)": {
                "params": {
                    "_set": string;
                };
                "return": string;
            };
            "exchangeIds(uint8)": {
                "params": {
                    "_exchangeId": string;
                };
                "return": string;
            };
            "exchanges()": {
                "return": string;
            };
            "factories()": {
                "return": string;
            };
            "isOwner()": {
                "return": string;
            };
            "modules()": {
                "return": string;
            };
            "operationState()": {
                "return": string;
            };
            "owner()": {
                "return": string;
            };
            "priceLibraries()": {
                "return": string;
            };
            "reenableSet(address)": {
                "params": {
                    "_set": string;
                };
            };
            "removeExchange(uint8,address)": {
                "params": {
                    "_exchange": string;
                    "_exchangeId": string;
                };
            };
            "removeFactory(address)": {
                "params": {
                    "_factory": string;
                };
            };
            "removeModule(address)": {
                "params": {
                    "_module": string;
                };
            };
            "removePriceLibrary(address)": {
                "params": {
                    "_priceLibrary": string;
                };
            };
            "renounceOwnership()": {
                "details": string;
            };
            "setTimeLockPeriod(uint256)": {
                "params": {
                    "_timeLockPeriod": string;
                };
            };
            "setTokens()": {
                "return": string;
            };
            "transferOwnership(address)": {
                "details": string;
                "params": {
                    "newOwner": string;
                };
            };
            "transferProxy()": {
                "return": string;
            };
            "validFactories(address)": {
                "params": {
                    "_factory": string;
                };
                "return": string;
            };
            "validModules(address)": {
                "params": {
                    "_module": string;
                };
                "return": string;
            };
            "validPriceLibraries(address)": {
                "params": {
                    "_priceLibrary": string;
                };
                "return": string;
            };
            "validSets(address)": {
                "params": {
                    "_set": string;
                };
                "return": string;
            };
            "vault()": {
                "return": string;
            };
        };
        "title": string;
    };
    "userdoc": {
        "methods": {
            "addExchange(uint8,address)": {
                "notice": string;
            };
            "addFactory(address)": {
                "notice": string;
            };
            "addModule(address)": {
                "notice": string;
            };
            "addPriceLibrary(address)": {
                "notice": string;
            };
            "disableSet(address)": {
                "notice": string;
            };
            "disabledSets(address)": {
                "notice": string;
            };
            "exchangeIds(uint8)": {
                "notice": string;
            };
            "exchanges()": {
                "notice": string;
            };
            "factories()": {
                "notice": string;
            };
            "modules()": {
                "notice": string;
            };
            "operationState()": {
                "notice": string;
            };
            "priceLibraries()": {
                "notice": string;
            };
            "reenableSet(address)": {
                "notice": string;
            };
            "removeExchange(uint8,address)": {
                "notice": string;
            };
            "removeFactory(address)": {
                "notice": string;
            };
            "removeModule(address)": {
                "notice": string;
            };
            "removePriceLibrary(address)": {
                "notice": string;
            };
            "renounceOwnership()": {
                "notice": string;
            };
            "setTimeLockPeriod(uint256)": {
                "notice": string;
            };
            "setTokens()": {
                "notice": string;
            };
            "transferProxy()": {
                "notice": string;
            };
            "validFactories(address)": {
                "notice": string;
            };
            "validModules(address)": {
                "notice": string;
            };
            "validPriceLibraries(address)": {
                "notice": string;
            };
            "validSets(address)": {
                "notice": string;
            };
            "vault()": {
                "notice": string;
            };
        };
    };
};
