export declare const CoreModuleInteraction: {
    "contractName": string;
    "abi": {
        "constant": boolean;
        "inputs": {
            "name": string;
            "type": string;
        }[];
        "name": string;
        "outputs": {
            "name": string;
            "type": string;
        }[];
        "payable": boolean;
        "stateMutability": string;
        "type": string;
    }[];
    "metadata": string;
    "bytecode": string;
    "deployedBytecode": string;
    "sourceMap": string;
    "deployedSourceMap": string;
    "source": string;
    "sourcePath": string;
    "compiler": {
        "name": string;
        "version": string;
    };
    "networks": {};
    "schemaVersion": string;
    "updatedAt": string;
    "devdoc": {
        "author": string;
        "methods": {
            "batchDecrementTokenOwnerModule(address[],address,uint256[])": {
                "params": {
                    "_owner": string;
                    "_quantities": string;
                    "_tokens": string;
                };
            };
            "batchDepositModule(address,address,address[],uint256[])": {
                "params": {
                    "_from": string;
                    "_quantities": string;
                    "_to": string;
                    "_tokens": string;
                };
            };
            "batchIncrementTokenOwnerModule(address[],address,uint256[])": {
                "params": {
                    "_owner": string;
                    "_quantities": string;
                    "_tokens": string;
                };
            };
            "batchTransferBalanceModule(address[],address,address,uint256[])": {
                "params": {
                    "_from": string;
                    "_quantities": string;
                    "_to": string;
                    "_tokens": string;
                };
            };
            "batchTransferModule(address[],uint256[],address,address)": {
                "params": {
                    "_from": string;
                    "_quantities": string;
                    "_to": string;
                    "_tokens": string;
                };
            };
            "batchWithdrawModule(address,address,address[],uint256[])": {
                "params": {
                    "_from": string;
                    "_quantities": string;
                    "_to": string;
                    "_tokens": string;
                };
            };
            "depositModule(address,address,address,uint256)": {
                "params": {
                    "_from": string;
                    "_quantity": string;
                    "_to": string;
                    "_token": string;
                };
            };
            "disabledSets(address)": {
                "params": {
                    "_set": string;
                };
                "return": string;
            };
            "exchangeIds(uint8)": {
                "params": {
                    "_exchangeId": string;
                };
                "return": string;
            };
            "exchanges()": {
                "return": string;
            };
            "factories()": {
                "return": string;
            };
            "issueInVaultModule(address,address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_recipient": string;
                    "_set": string;
                };
            };
            "issueModule(address,address,address,uint256)": {
                "params": {
                    "_componentOwner": string;
                    "_quantity": string;
                    "_set": string;
                    "_setRecipient": string;
                };
            };
            "modules()": {
                "return": string;
            };
            "operationState()": {
                "return": string;
            };
            "priceLibraries()": {
                "return": string;
            };
            "redeemModule(address,address,address,uint256)": {
                "params": {
                    "_burnAddress": string;
                    "_incrementAddress": string;
                    "_quantity": string;
                    "_set": string;
                };
            };
            "setTokens()": {
                "return": string;
            };
            "transferModule(address,uint256,address,address)": {
                "params": {
                    "_from": string;
                    "_quantity": string;
                    "_to": string;
                    "_token": string;
                };
            };
            "transferProxy()": {
                "return": string;
            };
            "validFactories(address)": {
                "params": {
                    "_factory": string;
                };
                "return": string;
            };
            "validModules(address)": {
                "params": {
                    "_module": string;
                };
                "return": string;
            };
            "validPriceLibraries(address)": {
                "params": {
                    "_priceLibrary": string;
                };
                "return": string;
            };
            "validSets(address)": {
                "params": {
                    "_set": string;
                };
                "return": string;
            };
            "vault()": {
                "return": string;
            };
            "withdrawModule(address,address,address,uint256)": {
                "params": {
                    "_from": string;
                    "_quantity": string;
                    "_to": string;
                    "_token": string;
                };
            };
        };
        "title": string;
    };
    "userdoc": {
        "methods": {
            "batchDecrementTokenOwnerModule(address[],address,uint256[])": {
                "notice": string;
            };
            "batchDepositModule(address,address,address[],uint256[])": {
                "notice": string;
            };
            "batchIncrementTokenOwnerModule(address[],address,uint256[])": {
                "notice": string;
            };
            "batchTransferBalanceModule(address[],address,address,uint256[])": {
                "notice": string;
            };
            "batchTransferModule(address[],uint256[],address,address)": {
                "notice": string;
            };
            "batchWithdrawModule(address,address,address[],uint256[])": {
                "notice": string;
            };
            "depositModule(address,address,address,uint256)": {
                "notice": string;
            };
            "disabledSets(address)": {
                "notice": string;
            };
            "exchangeIds(uint8)": {
                "notice": string;
            };
            "exchanges()": {
                "notice": string;
            };
            "factories()": {
                "notice": string;
            };
            "issueInVaultModule(address,address,uint256)": {
                "notice": string;
            };
            "issueModule(address,address,address,uint256)": {
                "notice": string;
            };
            "modules()": {
                "notice": string;
            };
            "operationState()": {
                "notice": string;
            };
            "priceLibraries()": {
                "notice": string;
            };
            "redeemModule(address,address,address,uint256)": {
                "notice": string;
            };
            "setTokens()": {
                "notice": string;
            };
            "transferModule(address,uint256,address,address)": {
                "notice": string;
            };
            "transferProxy()": {
                "notice": string;
            };
            "validFactories(address)": {
                "notice": string;
            };
            "validModules(address)": {
                "notice": string;
            };
            "validPriceLibraries(address)": {
                "notice": string;
            };
            "validSets(address)": {
                "notice": string;
            };
            "vault()": {
                "notice": string;
            };
            "withdrawModule(address,address,address,uint256)": {
                "notice": string;
            };
        };
    };
};
