export declare const ICore: {
    "contractName": string;
    "abi": {
        "constant": boolean;
        "inputs": {
            "name": string;
            "type": string;
        }[];
        "name": string;
        "outputs": {
            "name": string;
            "type": string;
        }[];
        "payable": boolean;
        "stateMutability": string;
        "type": string;
    }[];
    "metadata": string;
    "bytecode": string;
    "deployedBytecode": string;
    "sourceMap": string;
    "deployedSourceMap": string;
    "source": string;
    "sourcePath": string;
    "compiler": {
        "name": string;
        "version": string;
    };
    "networks": {};
    "schemaVersion": string;
    "updatedAt": string;
    "devdoc": {
        "author": string;
        "methods": {
            "batchDecrementTokenOwnerModule(address[],address,uint256[])": {
                "params": {
                    "_owner": string;
                    "_quantities": string;
                    "_tokens": string;
                };
            };
            "batchDeposit(address[],uint256[])": {
                "params": {
                    "_quantities": string;
                    "_tokens": string;
                };
            };
            "batchDepositModule(address,address,address[],uint256[])": {
                "params": {
                    "_from": string;
                    "_quantities": string;
                    "_to": string;
                    "_tokens": string;
                };
            };
            "batchIncrementTokenOwnerModule(address[],address,uint256[])": {
                "params": {
                    "_owner": string;
                    "_quantities": string;
                    "_tokens": string;
                };
            };
            "batchTransferBalanceModule(address[],address,address,uint256[])": {
                "params": {
                    "_from": string;
                    "_quantities": string;
                    "_to": string;
                    "_tokens": string;
                };
            };
            "batchTransferModule(address[],uint256[],address,address)": {
                "params": {
                    "_from": string;
                    "_quantities": string;
                    "_to": string;
                    "_tokens": string;
                };
            };
            "batchWithdraw(address[],uint256[])": {
                "params": {
                    "_quantities": string;
                    "_tokens": string;
                };
            };
            "batchWithdrawModule(address,address,address[],uint256[])": {
                "params": {
                    "_from": string;
                    "_quantities": string;
                    "_to": string;
                    "_tokens": string;
                };
            };
            "createSet(address,address[],uint256[],uint256,bytes32,bytes32,bytes)": {
                "params": {
                    "_callData": string;
                    "_components": string;
                    "_factory": string;
                    "_name": string;
                    "_naturalUnit": string;
                    "_symbol": string;
                    "_units": string;
                };
                "return": string;
            };
            "deposit(address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_token": string;
                };
            };
            "depositModule(address,address,address,uint256)": {
                "params": {
                    "_from": string;
                    "_quantity": string;
                    "_to": string;
                    "_token": string;
                };
            };
            "exchangeIds(uint8)": {
                "params": {
                    "_exchangeId": string;
                };
                "return": string;
            };
            "internalTransfer(address,address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_to": string;
                    "_token": string;
                };
            };
            "issue(address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_set": string;
                };
            };
            "issueInVault(address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_set": string;
                };
            };
            "issueModule(address,address,address,uint256)": {
                "params": {
                    "_owner": string;
                    "_quantity": string;
                    "_recipient": string;
                    "_set": string;
                };
            };
            "issueTo(address,address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_recipient": string;
                    "_set": string;
                };
            };
            "redeem(address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_set": string;
                };
            };
            "redeemAndWithdrawTo(address,address,uint256,uint256)": {
                "params": {
                    "_quantity": string;
                    "_set": string;
                    "_to": string;
                    "_toExclude": string;
                };
            };
            "redeemInVault(address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_set": string;
                };
            };
            "redeemModule(address,address,address,uint256)": {
                "params": {
                    "_burnAddress": string;
                    "_incrementAddress": string;
                    "_quantity": string;
                    "_set": string;
                };
            };
            "redeemTo(address,address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_recipient": string;
                    "_set": string;
                };
            };
            "transferModule(address,uint256,address,address)": {
                "params": {
                    "_from": string;
                    "_quantity": string;
                    "_to": string;
                    "_token": string;
                };
            };
            "transferProxy()": {
                "return": string;
            };
            "validPriceLibraries(address)": {
                "params": {
                    "_priceLibrary": string;
                };
                "return": string;
            };
            "vault()": {
                "return": string;
            };
            "withdraw(address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_token": string;
                };
            };
            "withdrawModule(address,address,address,uint256)": {
                "params": {
                    "_from": string;
                    "_quantity": string;
                    "_to": string;
                    "_token": string;
                };
            };
        };
        "title": string;
    };
    "userdoc": {
        "methods": {
            "batchDecrementTokenOwnerModule(address[],address,uint256[])": {
                "notice": string;
            };
            "batchDeposit(address[],uint256[])": {
                "notice": string;
            };
            "batchDepositModule(address,address,address[],uint256[])": {
                "notice": string;
            };
            "batchIncrementTokenOwnerModule(address[],address,uint256[])": {
                "notice": string;
            };
            "batchTransferBalanceModule(address[],address,address,uint256[])": {
                "notice": string;
            };
            "batchTransferModule(address[],uint256[],address,address)": {
                "notice": string;
            };
            "batchWithdraw(address[],uint256[])": {
                "notice": string;
            };
            "batchWithdrawModule(address,address,address[],uint256[])": {
                "notice": string;
            };
            "createSet(address,address[],uint256[],uint256,bytes32,bytes32,bytes)": {
                "notice": string;
            };
            "deposit(address,uint256)": {
                "notice": string;
            };
            "depositModule(address,address,address,uint256)": {
                "notice": string;
            };
            "exchangeIds(uint8)": {
                "notice": string;
            };
            "internalTransfer(address,address,uint256)": {
                "notice": string;
            };
            "issue(address,uint256)": {
                "notice": string;
            };
            "issueInVault(address,uint256)": {
                "notice": string;
            };
            "issueModule(address,address,address,uint256)": {
                "notice": string;
            };
            "issueTo(address,address,uint256)": {
                "notice": string;
            };
            "redeem(address,uint256)": {
                "notice": string;
            };
            "redeemAndWithdrawTo(address,address,uint256,uint256)": {
                "notice": string;
            };
            "redeemInVault(address,uint256)": {
                "notice": string;
            };
            "redeemModule(address,address,address,uint256)": {
                "notice": string;
            };
            "redeemTo(address,address,uint256)": {
                "notice": string;
            };
            "transferModule(address,uint256,address,address)": {
                "notice": string;
            };
            "transferProxy()": {
                "notice": string;
            };
            "validPriceLibraries(address)": {
                "notice": string;
            };
            "vault()": {
                "notice": string;
            };
            "withdraw(address,uint256)": {
                "notice": string;
            };
            "withdrawModule(address,address,address,uint256)": {
                "notice": string;
            };
        };
    };
};
