export declare const IWrapperFunctions: {
    "contractName": string;
    "abi": {
        "constant": boolean;
        "inputs": ({
            "components": {
                "name": string;
                "type": string;
            }[];
            "name": string;
            "type": string;
        } | {
            "name": string;
            "type": string;
            "components"?: undefined;
        })[];
        "name": string;
        "outputs": {
            "components": {
                "name": string;
                "type": string;
            }[];
            "name": string;
            "type": string;
        }[];
        "payable": boolean;
        "stateMutability": string;
        "type": string;
    }[];
    "metadata": string;
    "bytecode": string;
    "deployedBytecode": string;
    "sourceMap": string;
    "deployedSourceMap": string;
    "source": string;
    "sourcePath": string;
    "compiler": {
        "name": string;
        "version": string;
    };
    "networks": {};
    "schemaVersion": string;
    "updatedAt": string;
    "devdoc": {
        "methods": {
            "batchCancelOrders((address,address,address,address,uint256,uint256,uint256,uint256,uint256,uint256,bytes,bytes)[])": {
                "details": string;
                "params": {
                    "orders": string;
                };
            };
            "batchFillOrKillOrders((address,address,address,address,uint256,uint256,uint256,uint256,uint256,uint256,bytes,bytes)[],uint256[],bytes[])": {
                "details": string;
                "params": {
                    "orders": string;
                    "signatures": string;
                    "takerAssetFillAmounts": string;
                };
                "return": string;
            };
            "batchFillOrders((address,address,address,address,uint256,uint256,uint256,uint256,uint256,uint256,bytes,bytes)[],uint256[],bytes[])": {
                "details": string;
                "params": {
                    "orders": string;
                    "signatures": string;
                    "takerAssetFillAmounts": string;
                };
                "return": string;
            };
            "batchFillOrdersNoThrow((address,address,address,address,uint256,uint256,uint256,uint256,uint256,uint256,bytes,bytes)[],uint256[],bytes[])": {
                "details": string;
                "params": {
                    "orders": string;
                    "signatures": string;
                    "takerAssetFillAmounts": string;
                };
                "return": string;
            };
            "fillOrKillOrder((address,address,address,address,uint256,uint256,uint256,uint256,uint256,uint256,bytes,bytes),uint256,bytes)": {
                "details": string;
                "params": {
                    "order": string;
                    "signature": string;
                    "takerAssetFillAmount": string;
                };
            };
            "fillOrderNoThrow((address,address,address,address,uint256,uint256,uint256,uint256,uint256,uint256,bytes,bytes),uint256,bytes)": {
                "details": string;
                "params": {
                    "order": string;
                    "signature": string;
                    "takerAssetFillAmount": string;
                };
                "return": string;
            };
            "marketBuyOrders((address,address,address,address,uint256,uint256,uint256,uint256,uint256,uint256,bytes,bytes)[],uint256,bytes[])": {
                "details": string;
                "params": {
                    "makerAssetFillAmount": string;
                    "orders": string;
                    "signatures": string;
                };
                "return": string;
            };
            "marketBuyOrdersNoThrow((address,address,address,address,uint256,uint256,uint256,uint256,uint256,uint256,bytes,bytes)[],uint256,bytes[])": {
                "details": string;
                "params": {
                    "makerAssetFillAmount": string;
                    "orders": string;
                    "signatures": string;
                };
                "return": string;
            };
            "marketSellOrders((address,address,address,address,uint256,uint256,uint256,uint256,uint256,uint256,bytes,bytes)[],uint256,bytes[])": {
                "details": string;
                "params": {
                    "orders": string;
                    "signatures": string;
                    "takerAssetFillAmount": string;
                };
                "return": string;
            };
            "marketSellOrdersNoThrow((address,address,address,address,uint256,uint256,uint256,uint256,uint256,uint256,bytes,bytes)[],uint256,bytes[])": {
                "details": string;
                "params": {
                    "orders": string;
                    "signatures": string;
                    "takerAssetFillAmount": string;
                };
                "return": string;
            };
        };
    };
    "userdoc": {
        "methods": {};
    };
};
