export declare const TWAPLiquidator: {
    "contractName": string;
    "abi": ({
        "constant": boolean;
        "inputs": {
            "name": string;
            "type": string;
        }[];
        "name": string;
        "outputs": ({
            "components": ({
                "components": {
                    "name": string;
                    "type": string;
                }[];
                "name": string;
                "type": string;
            } | {
                "name": string;
                "type": string;
                "components"?: undefined;
            })[];
            "name": string;
            "type": string;
        } | {
            "name": string;
            "type": string;
            "components"?: undefined;
        })[];
        "payable": boolean;
        "stateMutability": string;
        "type": string;
        "anonymous"?: undefined;
    } | {
        "inputs": ({
            "name": string;
            "type": string;
            "components"?: undefined;
        } | {
            "components": ({
                "name": string;
                "type": string;
                "components"?: undefined;
            } | {
                "components": {
                    "name": string;
                    "type": string;
                }[];
                "name": string;
                "type": string;
            })[];
            "name": string;
            "type": string;
        })[];
        "payable": boolean;
        "stateMutability": string;
        "type": string;
        "constant"?: undefined;
        "name"?: undefined;
        "outputs"?: undefined;
        "anonymous"?: undefined;
    } | {
        "anonymous": boolean;
        "inputs": {
            "indexed": boolean;
            "name": string;
            "type": string;
        }[];
        "name": string;
        "type": string;
        "constant"?: undefined;
        "outputs"?: undefined;
        "payable"?: undefined;
        "stateMutability"?: undefined;
    } | {
        "constant": boolean;
        "inputs": ({
            "name": string;
            "type": string;
            "components"?: undefined;
        } | {
            "components": {
                "name": string;
                "type": string;
            }[];
            "name": string;
            "type": string;
        })[];
        "name": string;
        "outputs": any[];
        "payable": boolean;
        "stateMutability": string;
        "type": string;
        "anonymous"?: undefined;
    })[];
    "metadata": string;
    "bytecode": string;
    "deployedBytecode": string;
    "sourceMap": string;
    "deployedSourceMap": string;
    "source": string;
    "sourcePath": string;
    "compiler": {
        "name": string;
        "version": string;
    };
    "networks": {};
    "schemaVersion": string;
    "updatedAt": string;
    "devdoc": {
        "author": string;
        "methods": {
            "constructor": {
                "params": {
                    "_assetPairVolumeBounds": string;
                    "_auctionPeriod": string;
                    "_core": string;
                    "_name": string;
                    "_oracleWhiteList": string;
                    "_rangeEnd": string;
                    "_rangeStart": string;
                };
            };
            "getBidPrice(address,uint256)": {
                "params": {
                    "_quantity": string;
                    "_set": string;
                };
                "return": string;
            };
            "getLiquidatorData(uint256,uint256)": {
                "return": string;
            };
            "isOwner()": {
                "return": string;
            };
            "iterateChunkAuction(address)": {
                "params": {
                    "_set": string;
                };
            };
            "owner()": {
                "return": string;
            };
            "placeBid(uint256)": {
                "params": {
                    "_quantity": string;
                };
                "return": string;
            };
            "renounceOwnership()": {
                "details": string;
            };
            "setChunkSizeBounds(address,address,(uint256,uint256))": {
                "params": {
                    "_assetOne": string;
                    "_assetPairVolumeBounds": string;
                    "_assetTwo": string;
                };
            };
            "startRebalance(address,address,uint256,bytes)": {
                "params": {
                    "_currentSet": string;
                    "_liquidatorData": string;
                    "_nextSet": string;
                    "_startingCurrentSetQuantity": string;
                };
            };
            "transferOwnership(address)": {
                "details": string;
                "params": {
                    "newOwner": string;
                };
            };
        };
        "title": string;
    };
    "userdoc": {
        "methods": {
            "constructor": string;
            "endFailedRebalance()": {
                "notice": string;
            };
            "getBidPrice(address,uint256)": {
                "notice": string;
            };
            "getLiquidatorData(uint256,uint256)": {
                "notice": string;
            };
            "iterateChunkAuction(address)": {
                "notice": string;
            };
            "placeBid(uint256)": {
                "notice": string;
            };
            "renounceOwnership()": {
                "notice": string;
            };
            "setChunkSizeBounds(address,address,(uint256,uint256))": {
                "notice": string;
            };
            "settleRebalance()": {
                "notice": string;
            };
            "startRebalance(address,address,uint256,bytes)": {
                "notice": string;
            };
        };
    };
};
