import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class AddressToAddressWhiteListContract extends BaseContract {
    keys: {
        callAsync(index_0: BigNumber, defaultBlock?: any): Promise<string>;
    };
    timeLockedUpgrades: {
        callAsync(index_0: string, defaultBlock?: any): Promise<BigNumber>;
    };
    renounceOwnership: {
        sendTransactionAsync(txData?: Tx): Promise<string>;
        estimateGasAsync(txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(txData?: Tx): string;
        callAsync(txData?: Tx): Promise<void>;
    };
    timeLockPeriod: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    owner: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    isOwner: {
        callAsync(defaultBlock?: any): Promise<boolean>;
    };
    setTimeLockPeriod: {
        sendTransactionAsync(_timeLockPeriod: BigNumber, txData?: Tx): Promise<string>;
        estimateGasAsync(_timeLockPeriod: BigNumber, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_timeLockPeriod: BigNumber, txData?: Tx): string;
        callAsync(_timeLockPeriod: BigNumber, txData?: Tx): Promise<void>;
    };
    whitelist: {
        callAsync(index_0: string, defaultBlock?: any): Promise<string>;
    };
    removeRegisteredUpgrade: {
        sendTransactionAsync(_upgradeHash: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_upgradeHash: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_upgradeHash: string, txData?: Tx): string;
        callAsync(_upgradeHash: string, txData?: Tx): Promise<void>;
    };
    transferOwnership: {
        sendTransactionAsync(newOwner: string, txData?: Tx): Promise<string>;
        estimateGasAsync(newOwner: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(newOwner: string, txData?: Tx): string;
        callAsync(newOwner: string, txData?: Tx): Promise<void>;
    };
    addPair: {
        sendTransactionAsync(_key: string, _value: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_key: string, _value: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_key: string, _value: string, txData?: Tx): string;
        callAsync(_key: string, _value: string, txData?: Tx): Promise<void>;
    };
    removePair: {
        sendTransactionAsync(_key: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_key: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_key: string, txData?: Tx): string;
        callAsync(_key: string, txData?: Tx): Promise<void>;
    };
    editPair: {
        sendTransactionAsync(_key: string, _value: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_key: string, _value: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_key: string, _value: string, txData?: Tx): string;
        callAsync(_key: string, _value: string, txData?: Tx): Promise<void>;
    };
    validAddresses: {
        callAsync(defaultBlock?: any): Promise<string[]>;
    };
    getValues: {
        callAsync(_key: string[], defaultBlock?: any): Promise<string[]>;
    };
    getValue: {
        callAsync(_key: string, defaultBlock?: any): Promise<string>;
    };
    areValidAddresses: {
        callAsync(_keys: string[], defaultBlock?: any): Promise<boolean>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<AddressToAddressWhiteListContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<AddressToAddressWhiteListContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
