import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber, UInt } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class CTokenExchangeIssuanceModuleContract extends BaseContract {
    vaultInstance: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    transferProxy: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    coreInstance: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    core: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    vault: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    cTokenWhiteList: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    exchangeIssue: {
        sendTransactionAsync(_exchangeIssuanceParams: {
            setAddress: string;
            quantity: BigNumber;
            sendTokenExchangeIds: UInt[];
            sendTokens: string[];
            sendTokenAmounts: BigNumber[];
            receiveTokens: string[];
            receiveTokenAmounts: BigNumber[];
        }, _orderData: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_exchangeIssuanceParams: {
            setAddress: string;
            quantity: BigNumber;
            sendTokenExchangeIds: UInt[];
            sendTokens: string[];
            sendTokenAmounts: BigNumber[];
            receiveTokens: string[];
            receiveTokenAmounts: BigNumber[];
        }, _orderData: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_exchangeIssuanceParams: {
            setAddress: string;
            quantity: BigNumber;
            sendTokenExchangeIds: UInt[];
            sendTokens: string[];
            sendTokenAmounts: BigNumber[];
            receiveTokens: string[];
            receiveTokenAmounts: BigNumber[];
        }, _orderData: string, txData?: Tx): string;
        callAsync(_exchangeIssuanceParams: {
            setAddress: string;
            quantity: BigNumber;
            sendTokenExchangeIds: UInt[];
            sendTokens: string[];
            sendTokenAmounts: BigNumber[];
            receiveTokens: string[];
            receiveTokenAmounts: BigNumber[];
        }, _orderData: string, txData?: Tx): Promise<void>;
    };
    exchangeRedeem: {
        sendTransactionAsync(_exchangeIssuanceParams: {
            setAddress: string;
            quantity: BigNumber;
            sendTokenExchangeIds: UInt[];
            sendTokens: string[];
            sendTokenAmounts: BigNumber[];
            receiveTokens: string[];
            receiveTokenAmounts: BigNumber[];
        }, _orderData: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_exchangeIssuanceParams: {
            setAddress: string;
            quantity: BigNumber;
            sendTokenExchangeIds: UInt[];
            sendTokens: string[];
            sendTokenAmounts: BigNumber[];
            receiveTokens: string[];
            receiveTokenAmounts: BigNumber[];
        }, _orderData: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_exchangeIssuanceParams: {
            setAddress: string;
            quantity: BigNumber;
            sendTokenExchangeIds: UInt[];
            sendTokens: string[];
            sendTokenAmounts: BigNumber[];
            receiveTokens: string[];
            receiveTokenAmounts: BigNumber[];
        }, _orderData: string, txData?: Tx): string;
        callAsync(_exchangeIssuanceParams: {
            setAddress: string;
            quantity: BigNumber;
            sendTokenExchangeIds: UInt[];
            sendTokens: string[];
            sendTokenAmounts: BigNumber[];
            receiveTokens: string[];
            receiveTokenAmounts: BigNumber[];
        }, _orderData: string, txData?: Tx): Promise<void>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<CTokenExchangeIssuanceModuleContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<CTokenExchangeIssuanceModuleContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
