import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class CommonMathContract extends BaseContract {
    MAX_UINT_256: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    SCALE_FACTOR: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<CommonMathContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<CommonMathContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
