import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class CommonValidationsLibraryContract extends BaseContract {
    validateNonEmpty: {
        callAsync(_addressArray: string[], defaultBlock?: any): Promise<void>;
    };
    validateEqualLength: {
        callAsync(_addressArray: string[], _uint256Array: BigNumber[], defaultBlock?: any): Promise<void>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<CommonValidationsLibraryContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<CommonValidationsLibraryContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
