import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class ERC20WrapperMockContract extends BaseContract {
    allowance: {
        callAsync(_token: string, _owner: string, _spender: string, defaultBlock?: any): Promise<BigNumber>;
    };
    approve: {
        sendTransactionAsync(_token: string, _spender: string, _quantity: BigNumber, txData?: Tx): Promise<string>;
        estimateGasAsync(_token: string, _spender: string, _quantity: BigNumber, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_token: string, _spender: string, _quantity: BigNumber, txData?: Tx): string;
        callAsync(_token: string, _spender: string, _quantity: BigNumber, txData?: Tx): Promise<void>;
    };
    ensureAllowance: {
        sendTransactionAsync(_token: string, _owner: string, _spender: string, _quantity: BigNumber, txData?: Tx): Promise<string>;
        estimateGasAsync(_token: string, _owner: string, _spender: string, _quantity: BigNumber, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_token: string, _owner: string, _spender: string, _quantity: BigNumber, txData?: Tx): string;
        callAsync(_token: string, _owner: string, _spender: string, _quantity: BigNumber, txData?: Tx): Promise<void>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<ERC20WrapperMockContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<ERC20WrapperMockContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
