import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class FeeCalculatorMockContract extends BaseContract {
    feeValue: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    testInitialize: {
        sendTransactionAsync(_feeCalculator: string, _feeCalculatorData: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_feeCalculator: string, _feeCalculatorData: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_feeCalculator: string, _feeCalculatorData: string, txData?: Tx): string;
        callAsync(_feeCalculator: string, _feeCalculatorData: string, txData?: Tx): Promise<void>;
    };
    testGetFee: {
        callAsync(_feeCalculator: string, defaultBlock?: any): Promise<BigNumber>;
    };
    testUpdateAndGetFee: {
        sendTransactionAsync(_feeCalculator: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_feeCalculator: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_feeCalculator: string, txData?: Tx): string;
        callAsync(_feeCalculator: string, txData?: Tx): Promise<void>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<FeeCalculatorMockContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<FeeCalculatorMockContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
