import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class FixedFeeCalculatorMockContract extends BaseContract {
    initialize: {
        sendTransactionAsync(_feeCalculatorData: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_feeCalculatorData: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_feeCalculatorData: string, txData?: Tx): string;
        callAsync(_feeCalculatorData: string, txData?: Tx): Promise<void>;
    };
    adjustFee: {
        sendTransactionAsync(_newFeePercentage: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_newFeePercentage: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_newFeePercentage: string, txData?: Tx): string;
        callAsync(_newFeePercentage: string, txData?: Tx): Promise<void>;
    };
    getFee: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    isInitialized: {
        callAsync(index_0: string, defaultBlock?: any): Promise<boolean>;
    };
    isCalled: {
        callAsync(defaultBlock?: any): Promise<boolean>;
    };
    fees: {
        callAsync(index_0: string, defaultBlock?: any): Promise<BigNumber>;
    };
    updateAndGetFee: {
        sendTransactionAsync(txData?: Tx): Promise<string>;
        estimateGasAsync(txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(txData?: Tx): string;
        callAsync(txData?: Tx): Promise<BigNumber>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<FixedFeeCalculatorMockContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<FixedFeeCalculatorMockContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
