import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BaseContract } from '../base_contract';
export declare class IAddressToAddressWhiteListContract extends BaseContract {
    whitelist: {
        callAsync(_key: string, defaultBlock?: any): Promise<string>;
    };
    areValidAddresses: {
        callAsync(_keys: string[], defaultBlock?: any): Promise<boolean>;
    };
    getValues: {
        callAsync(_key: string[], defaultBlock?: any): Promise<string[]>;
    };
    getValue: {
        callAsync(_key: string, defaultBlock?: any): Promise<string>;
    };
    validAddresses: {
        callAsync(defaultBlock?: any): Promise<string[]>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<IAddressToAddressWhiteListContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<IAddressToAddressWhiteListContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
