import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class IAssetDataContract extends BaseContract {
    ERC20Token: {
        callAsync(tokenContract: string, defaultBlock?: any): Promise<void>;
    };
    ERC721Token: {
        callAsync(tokenContract: string, tokenId: BigNumber, receiverData: string, defaultBlock?: any): Promise<void>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<IAssetDataContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<IAssetDataContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
