import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BaseContract } from '../base_contract';
export declare class IAssetProxyDispatcherContract extends BaseContract {
    registerAssetProxy: {
        sendTransactionAsync(assetProxyId: string, newAssetProxy: string, oldAssetProxy: string, txData?: Tx): Promise<string>;
        estimateGasAsync(assetProxyId: string, newAssetProxy: string, oldAssetProxy: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(assetProxyId: string, newAssetProxy: string, oldAssetProxy: string, txData?: Tx): string;
        callAsync(assetProxyId: string, newAssetProxy: string, oldAssetProxy: string, txData?: Tx): Promise<void>;
    };
    getAssetProxy: {
        callAsync(assetProxyId: string, defaultBlock?: any): Promise<string>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<IAssetProxyDispatcherContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<IAssetProxyDispatcherContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
