import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class IAuctionPriceCurveContract extends BaseContract {
    priceDivisor: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    validateAuctionPriceParameters: {
        callAsync(_auctionPriceParameters: {
            auctionStartTime: BigNumber;
            auctionTimeToPivot: BigNumber;
            auctionStartPrice: BigNumber;
            auctionPivotPrice: BigNumber;
        }, defaultBlock?: any): Promise<void>;
    };
    getCurrentPrice: {
        callAsync(_auctionPriceParameters: {
            auctionStartTime: BigNumber;
            auctionTimeToPivot: BigNumber;
            auctionStartPrice: BigNumber;
            auctionPivotPrice: BigNumber;
        }, defaultBlock?: any): Promise<[BigNumber, BigNumber]>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<IAuctionPriceCurveContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<IAuctionPriceCurveContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
