import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BaseContract } from '../base_contract';
export declare class IOracleWhiteListContract extends BaseContract {
    oracleWhiteList: {
        callAsync(_tokenAddress: string, defaultBlock?: any): Promise<string>;
    };
    areValidAddresses: {
        callAsync(_addresses: string[], defaultBlock?: any): Promise<boolean>;
    };
    getOracleAddressesByToken: {
        callAsync(_tokenAddresses: string[], defaultBlock?: any): Promise<string[]>;
    };
    getOracleAddressByToken: {
        callAsync(_token: string, defaultBlock?: any): Promise<string>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<IOracleWhiteListContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<IOracleWhiteListContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
