import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class IRebalanceAuctionModuleContract extends BaseContract {
    bidAndWithdraw: {
        sendTransactionAsync(_rebalancingSetToken: string, _quantity: BigNumber, _allowPartialFill: boolean, txData?: Tx): Promise<string>;
        estimateGasAsync(_rebalancingSetToken: string, _quantity: BigNumber, _allowPartialFill: boolean, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_rebalancingSetToken: string, _quantity: BigNumber, _allowPartialFill: boolean, txData?: Tx): string;
        callAsync(_rebalancingSetToken: string, _quantity: BigNumber, _allowPartialFill: boolean, txData?: Tx): Promise<void>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<IRebalanceAuctionModuleContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<IRebalanceAuctionModuleContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
