import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BaseContract } from '../base_contract';
export declare class ISignatureValidatorContract extends BaseContract {
    preSign: {
        sendTransactionAsync(hash: string, signerAddress: string, signature: string, txData?: Tx): Promise<string>;
        estimateGasAsync(hash: string, signerAddress: string, signature: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(hash: string, signerAddress: string, signature: string, txData?: Tx): string;
        callAsync(hash: string, signerAddress: string, signature: string, txData?: Tx): Promise<void>;
    };
    setSignatureValidatorApproval: {
        sendTransactionAsync(validatorAddress: string, approval: boolean, txData?: Tx): Promise<string>;
        estimateGasAsync(validatorAddress: string, approval: boolean, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(validatorAddress: string, approval: boolean, txData?: Tx): string;
        callAsync(validatorAddress: string, approval: boolean, txData?: Tx): Promise<void>;
    };
    isValidSignature: {
        callAsync(hash: string, signerAddress: string, signature: string, defaultBlock?: any): Promise<boolean>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<ISignatureValidatorContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<ISignatureValidatorContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
