import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class ITWAPAuctionGettersContract extends BaseContract {
    getOrderSize: {
        callAsync(_set: string, defaultBlock?: any): Promise<BigNumber>;
    };
    getOrderRemaining: {
        callAsync(_set: string, defaultBlock?: any): Promise<BigNumber>;
    };
    getTotalSetsRemaining: {
        callAsync(_set: string, defaultBlock?: any): Promise<BigNumber>;
    };
    getChunkSize: {
        callAsync(_set: string, defaultBlock?: any): Promise<BigNumber>;
    };
    getChunkAuctionPeriod: {
        callAsync(_set: string, defaultBlock?: any): Promise<BigNumber>;
    };
    getLastChunkAuctionEnd: {
        callAsync(_set: string, defaultBlock?: any): Promise<BigNumber>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<ITWAPAuctionGettersContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<ITWAPAuctionGettersContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
