import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class ITransactionsContract extends BaseContract {
    executeTransaction: {
        sendTransactionAsync(salt: BigNumber, signerAddress: string, data: string, signature: string, txData?: Tx): Promise<string>;
        estimateGasAsync(salt: BigNumber, signerAddress: string, data: string, signature: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(salt: BigNumber, signerAddress: string, data: string, signature: string, txData?: Tx): string;
        callAsync(salt: BigNumber, signerAddress: string, data: string, signature: string, txData?: Tx): Promise<void>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<ITransactionsContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<ITransactionsContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
