import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class ITransferProxyContract extends BaseContract {
    transfer: {
        sendTransactionAsync(_token: string, _quantity: BigNumber, _from: string, _to: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_token: string, _quantity: BigNumber, _from: string, _to: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_token: string, _quantity: BigNumber, _from: string, _to: string, txData?: Tx): string;
        callAsync(_token: string, _quantity: BigNumber, _from: string, _to: string, txData?: Tx): Promise<void>;
    };
    batchTransfer: {
        sendTransactionAsync(_tokens: string[], _quantities: BigNumber[], _from: string, _to: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_tokens: string[], _quantities: BigNumber[], _from: string, _to: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_tokens: string[], _quantities: BigNumber[], _from: string, _to: string, txData?: Tx): string;
        callAsync(_tokens: string[], _quantities: BigNumber[], _from: string, _to: string, txData?: Tx): Promise<void>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<ITransferProxyContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<ITransferProxyContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
