import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class InvalidReturnTokenMockContract extends BaseContract {
    name: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    totalSupply: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    decimals: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    symbol: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    transfer: {
        sendTransactionAsync(_to: string, _value: BigNumber, txData?: Tx): Promise<string>;
        estimateGasAsync(_to: string, _value: BigNumber, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_to: string, _value: BigNumber, txData?: Tx): string;
        callAsync(_to: string, _value: BigNumber, txData?: Tx): Promise<BigNumber>;
    };
    balanceOf: {
        callAsync(_owner: string, defaultBlock?: any): Promise<BigNumber>;
    };
    transferFrom: {
        sendTransactionAsync(_from: string, _to: string, _value: BigNumber, txData?: Tx): Promise<string>;
        estimateGasAsync(_from: string, _to: string, _value: BigNumber, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_from: string, _to: string, _value: BigNumber, txData?: Tx): string;
        callAsync(_from: string, _to: string, _value: BigNumber, txData?: Tx): Promise<BigNumber>;
    };
    approve: {
        sendTransactionAsync(_spender: string, _value: BigNumber, txData?: Tx): Promise<string>;
        estimateGasAsync(_spender: string, _value: BigNumber, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_spender: string, _value: BigNumber, txData?: Tx): string;
        callAsync(_spender: string, _value: BigNumber, txData?: Tx): Promise<BigNumber>;
    };
    allowance: {
        callAsync(_owner: string, _spender: string, defaultBlock?: any): Promise<BigNumber>;
    };
    increaseApproval: {
        sendTransactionAsync(_spender: string, _addedValue: BigNumber, txData?: Tx): Promise<string>;
        estimateGasAsync(_spender: string, _addedValue: BigNumber, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_spender: string, _addedValue: BigNumber, txData?: Tx): string;
        callAsync(_spender: string, _addedValue: BigNumber, txData?: Tx): Promise<BigNumber>;
    };
    decreaseApproval: {
        sendTransactionAsync(_spender: string, _subtractedValue: BigNumber, txData?: Tx): Promise<string>;
        estimateGasAsync(_spender: string, _subtractedValue: BigNumber, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_spender: string, _subtractedValue: BigNumber, txData?: Tx): string;
        callAsync(_spender: string, _subtractedValue: BigNumber, txData?: Tx): Promise<BigNumber>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<InvalidReturnTokenMockContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<InvalidReturnTokenMockContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
