import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class IWETHContract extends BaseContract {
    deposit: {
        sendTransactionAsync(txData?: Tx): Promise<string>;
        estimateGasAsync(txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(txData?: Tx): string;
        callAsync(txData?: Tx): Promise<void>;
    };
    withdraw: {
        sendTransactionAsync(wad: BigNumber, txData?: Tx): Promise<string>;
        estimateGasAsync(wad: BigNumber, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(wad: BigNumber, txData?: Tx): string;
        callAsync(wad: BigNumber, txData?: Tx): Promise<void>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<IWETHContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<IWETHContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
