import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class LiquidatorUtilsMockContract extends BaseContract {
    testCalculateRebalanceVolume: {
        callAsync(_currentSet: string, _nextSet: string, _oracleWhiteList: string, _currentSetQuantity: BigNumber, defaultBlock?: any): Promise<BigNumber>;
    };
    testCalculateAssetAllocation: {
        callAsync(_setToken: string, _oracleWhiteList: string, _asset: string, defaultBlock?: any): Promise<BigNumber>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<LiquidatorUtilsMockContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<LiquidatorUtilsMockContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
