import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BaseContract } from '../base_contract';
export declare class ModuleCoreStateV2Contract extends BaseContract {
    transferProxyInstance: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    vaultInstance: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    coreInstance: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<ModuleCoreStateV2Contract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<ModuleCoreStateV2Contract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
