import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class RebalancingSetCTokenBidderContract extends BaseContract {
    dataDescription: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    transferProxy: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    cTokenToUnderlying: {
        callAsync(index_0: string, defaultBlock?: any): Promise<string>;
    };
    rebalanceAuctionModule: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    bidAndWithdraw: {
        sendTransactionAsync(_rebalancingSetToken: string, _quantity: BigNumber, _allowPartialFill: boolean, txData?: Tx): Promise<string>;
        estimateGasAsync(_rebalancingSetToken: string, _quantity: BigNumber, _allowPartialFill: boolean, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_rebalancingSetToken: string, _quantity: BigNumber, _allowPartialFill: boolean, txData?: Tx): string;
        callAsync(_rebalancingSetToken: string, _quantity: BigNumber, _allowPartialFill: boolean, txData?: Tx): Promise<void>;
    };
    bidAndWithdrawTWAP: {
        sendTransactionAsync(_rebalancingSetToken: string, _quantity: BigNumber, _lastChunkTimestamp: BigNumber, _allowPartialFill: boolean, txData?: Tx): Promise<string>;
        estimateGasAsync(_rebalancingSetToken: string, _quantity: BigNumber, _lastChunkTimestamp: BigNumber, _allowPartialFill: boolean, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_rebalancingSetToken: string, _quantity: BigNumber, _lastChunkTimestamp: BigNumber, _allowPartialFill: boolean, txData?: Tx): string;
        callAsync(_rebalancingSetToken: string, _quantity: BigNumber, _lastChunkTimestamp: BigNumber, _allowPartialFill: boolean, txData?: Tx): Promise<void>;
    };
    getAddressAndBidPriceArray: {
        callAsync(_rebalancingSetToken: string, _quantity: BigNumber, defaultBlock?: any): Promise<[string[], BigNumber[], BigNumber[]]>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<RebalancingSetCTokenBidderContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<RebalancingSetCTokenBidderContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
