import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class RebalancingSetFeeMockContract extends BaseContract {
    unitShares: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    currentSet: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    naturalUnit: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    feeCalculator: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    fee: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    initialize: {
        sendTransactionAsync(_feeCallData: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_feeCallData: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_feeCallData: string, txData?: Tx): string;
        callAsync(_feeCallData: string, txData?: Tx): Promise<void>;
    };
    getFee: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    updateAndGetFee: {
        sendTransactionAsync(txData?: Tx): Promise<string>;
        estimateGasAsync(txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(txData?: Tx): string;
        callAsync(txData?: Tx): Promise<void>;
    };
    adjustFee: {
        sendTransactionAsync(_newFeePercentage: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_newFeePercentage: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_newFeePercentage: string, txData?: Tx): string;
        callAsync(_newFeePercentage: string, txData?: Tx): Promise<void>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<RebalancingSetFeeMockContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<RebalancingSetFeeMockContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
