import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class RebalancingSetIssuanceMockContract extends BaseContract {
    vaultInstance: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    coreInstance: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    core: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    vault: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    validateWETHIsAComponentOfSetMock: {
        sendTransactionAsync(_setAddress: string, _wrappedEtherAddress: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_setAddress: string, _wrappedEtherAddress: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_setAddress: string, _wrappedEtherAddress: string, txData?: Tx): string;
        callAsync(_setAddress: string, _wrappedEtherAddress: string, txData?: Tx): Promise<void>;
    };
    validateRebalancingSetIssuanceMock: {
        sendTransactionAsync(_rebalancingSetAddress: string, _rebalancingSetQuantity: BigNumber, txData?: Tx): Promise<string>;
        estimateGasAsync(_rebalancingSetAddress: string, _rebalancingSetQuantity: BigNumber, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_rebalancingSetAddress: string, _rebalancingSetQuantity: BigNumber, txData?: Tx): string;
        callAsync(_rebalancingSetAddress: string, _rebalancingSetQuantity: BigNumber, txData?: Tx): Promise<void>;
    };
    getBaseSetIssuanceRequiredQuantityMock: {
        sendTransactionAsync(_rebalancingSetAddress: string, _rebalancingSetQuantity: BigNumber, txData?: Tx): Promise<string>;
        estimateGasAsync(_rebalancingSetAddress: string, _rebalancingSetQuantity: BigNumber, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_rebalancingSetAddress: string, _rebalancingSetQuantity: BigNumber, txData?: Tx): string;
        callAsync(_rebalancingSetAddress: string, _rebalancingSetQuantity: BigNumber, txData?: Tx): Promise<BigNumber>;
    };
    getBaseSetRedeemQuantityMock: {
        sendTransactionAsync(_baseSetAddress: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_baseSetAddress: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_baseSetAddress: string, txData?: Tx): string;
        callAsync(_baseSetAddress: string, txData?: Tx): Promise<BigNumber>;
    };
    returnExcessBaseSetFromContractMock: {
        sendTransactionAsync(_baseSetAddress: string, _transferProxyAddress: string, _keepChangeInVault: boolean, txData?: Tx): Promise<string>;
        estimateGasAsync(_baseSetAddress: string, _transferProxyAddress: string, _keepChangeInVault: boolean, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_baseSetAddress: string, _transferProxyAddress: string, _keepChangeInVault: boolean, txData?: Tx): string;
        callAsync(_baseSetAddress: string, _transferProxyAddress: string, _keepChangeInVault: boolean, txData?: Tx): Promise<void>;
    };
    returnExcessBaseSetInVaultMock: {
        sendTransactionAsync(_baseSetAddress: string, _keepChangeInVault: boolean, txData?: Tx): Promise<string>;
        estimateGasAsync(_baseSetAddress: string, _keepChangeInVault: boolean, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_baseSetAddress: string, _keepChangeInVault: boolean, txData?: Tx): string;
        callAsync(_baseSetAddress: string, _keepChangeInVault: boolean, txData?: Tx): Promise<void>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<RebalancingSetIssuanceMockContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<RebalancingSetIssuanceMockContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
