import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class RebalancingSetTokenFactoryContract extends BaseContract {
    minimumTimeToPivot: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    maximumTimeToPivot: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    rebalanceComponentWhitelist: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    minimumRebalanceInterval: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    maximumNaturalUnit: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    minimumNaturalUnit: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    core: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    minimumProposalPeriod: {
        callAsync(defaultBlock?: any): Promise<BigNumber>;
    };
    createSet: {
        sendTransactionAsync(_components: string[], _units: BigNumber[], _naturalUnit: BigNumber, _name: string, _symbol: string, _callData: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_components: string[], _units: BigNumber[], _naturalUnit: BigNumber, _name: string, _symbol: string, _callData: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_components: string[], _units: BigNumber[], _naturalUnit: BigNumber, _name: string, _symbol: string, _callData: string, txData?: Tx): string;
        callAsync(_components: string[], _units: BigNumber[], _naturalUnit: BigNumber, _name: string, _symbol: string, _callData: string, txData?: Tx): Promise<string>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<RebalancingSetTokenFactoryContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<RebalancingSetTokenFactoryContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
