import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class SetTokenLibraryContract extends BaseContract {
    validateTokensAreComponents: {
        callAsync(_set: string, _tokens: string[], defaultBlock?: any): Promise<void>;
    };
    isMultipleOfSetNaturalUnit: {
        callAsync(_set: string, _quantity: BigNumber, defaultBlock?: any): Promise<void>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<SetTokenLibraryContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<SetTokenLibraryContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
