import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class SetTokenLibraryMockContract extends BaseContract {
    testValidateTokensAreComponents: {
        callAsync(_set: string, _tokens: string[], defaultBlock?: any): Promise<void>;
    };
    testIsMultipleOfSetNaturalUnit: {
        callAsync(_set: string, _quantity: BigNumber, defaultBlock?: any): Promise<void>;
    };
    testRequireValidSet: {
        callAsync(_core: string, _set: string, defaultBlock?: any): Promise<void>;
    };
    testGetSetDetails: {
        callAsync(_set: string, defaultBlock?: any): Promise<[BigNumber, string[], BigNumber[]]>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<SetTokenLibraryMockContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<SetTokenLibraryMockContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
