import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BaseContract } from '../base_contract';
export declare class TokenFlushMockContract extends BaseContract {
    transferProxyInstance: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    vaultInstance: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    coreInstance: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    returnExcessBaseSetFromContractMock: {
        sendTransactionAsync(_baseSetAddress: string, _returnAddress: string, _keepChangeInVault: boolean, txData?: Tx): Promise<string>;
        estimateGasAsync(_baseSetAddress: string, _returnAddress: string, _keepChangeInVault: boolean, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_baseSetAddress: string, _returnAddress: string, _keepChangeInVault: boolean, txData?: Tx): string;
        callAsync(_baseSetAddress: string, _returnAddress: string, _keepChangeInVault: boolean, txData?: Tx): Promise<void>;
    };
    returnExcessBaseSetInVaultMock: {
        sendTransactionAsync(_baseSetAddress: string, _returnAddress: string, _keepChangeInVault: boolean, txData?: Tx): Promise<string>;
        estimateGasAsync(_baseSetAddress: string, _returnAddress: string, _keepChangeInVault: boolean, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_baseSetAddress: string, _returnAddress: string, _keepChangeInVault: boolean, txData?: Tx): string;
        callAsync(_baseSetAddress: string, _returnAddress: string, _keepChangeInVault: boolean, txData?: Tx): Promise<void>;
    };
    returnExcessComponentsFromContractMock: {
        sendTransactionAsync(_baseSetToken: string, _returnAddress: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_baseSetToken: string, _returnAddress: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_baseSetToken: string, _returnAddress: string, txData?: Tx): string;
        callAsync(_baseSetToken: string, _returnAddress: string, txData?: Tx): Promise<void>;
    };
    returnExcessComponentsFromVaultMock: {
        sendTransactionAsync(_baseSetToken: string, _returnAddress: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_baseSetToken: string, _returnAddress: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_baseSetToken: string, _returnAddress: string, txData?: Tx): string;
        callAsync(_baseSetToken: string, _returnAddress: string, txData?: Tx): Promise<void>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<TokenFlushMockContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<TokenFlushMockContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
