import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class ZeroExExchangeWrapperContract extends BaseContract {
    zeroExExchange: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    setTransferProxy: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    zeroExToken: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    zeroExProxy: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    core: {
        callAsync(defaultBlock?: any): Promise<string>;
    };
    exchange: {
        sendTransactionAsync(_exchangeData: {
            caller: string;
            orderCount: BigNumber;
        }, _ordersData: string, txData?: Tx): Promise<string>;
        estimateGasAsync(_exchangeData: {
            caller: string;
            orderCount: BigNumber;
        }, _ordersData: string, txData?: Tx): Promise<number>;
        getABIEncodedTransactionData(_exchangeData: {
            caller: string;
            orderCount: BigNumber;
        }, _ordersData: string, txData?: Tx): string;
        callAsync(_exchangeData: {
            caller: string;
            orderCount: BigNumber;
        }, _ordersData: string, txData?: Tx): Promise<{}>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<ZeroExExchangeWrapperContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<ZeroExExchangeWrapperContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
