import Web3 from 'web3';
import Contract from "web3/eth/contract";
import { ABIDefinition } from "web3/eth/abi";
import { Tx } from "web3/eth/types";
import { BigNumber } from 'set-protocol-utils';
import { BaseContract } from '../base_contract';
export declare class ZeroExOrderLibraryMockContract extends BaseContract {
    parseOrderHeader: {
        callAsync(_ordersData: string, _offset: BigNumber, defaultBlock?: any): Promise<[BigNumber, BigNumber]>;
    };
    parseZeroExOrder: {
        callAsync(_ordersData: string, _offset: BigNumber, defaultBlock?: any): Promise<[string[], BigNumber[], string, string]>;
    };
    deploy(data: string, args: any[]): Promise<any>;
    static deployed(web3: Web3, defaults: Tx): Promise<ZeroExOrderLibraryMockContract>;
    static at(address: string, web3: Web3, defaults: Tx): Promise<ZeroExOrderLibraryMockContract>;
    constructor(web3ContractInstance: Contract, defaults: Tx);
    static getAbi(): ABIDefinition[];
}
