import { BigNumber } from 'bignumber.js';
import { Address } from 'set-protocol-utils';
export interface LinearAuction {
    auction: Auction;
    endTime: BigNumber;
    startPrice: BigNumber;
    endPrice: BigNumber;
}
export interface Price {
    numerator: BigNumber;
    denominator: BigNumber;
}
export interface TokenFlow {
    addresses: Address[];
    inflow: BigNumber[];
    outflow: BigNumber[];
}
export interface Auction {
    maxNaturalUnit: BigNumber;
    minimumBid: BigNumber;
    startTime: BigNumber;
    startingCurrentSets: BigNumber;
    remainingCurrentSets: BigNumber;
    combinedTokenArray: Address[];
    combinedCurrentSetUnits: BigNumber[];
    combinedNextSetUnits: BigNumber[];
}
export interface AssetPairVolumeBounds {
    assetOne: Address;
    assetTwo: Address;
    bounds: AssetChunkSizeBounds;
}
export interface AssetChunkSizeBounds {
    lower: BigNumber;
    upper: BigNumber;
}
export declare function getLinearAuction(input: any): LinearAuction;
