import { BigNumber } from 'bignumber.js';
import { Address, Log } from 'set-protocol-utils';
export declare function SetTokenCreated(_coreAddress: Address, _setTokenAddress: Address, _factory: Address, _components: Address[], _units: BigNumber[], _naturalUnit: BigNumber, _name: string, _symbol: string): Log;
export declare function OperationStateChanged(_coreAddress: Address, _prevState: BigNumber, _newState: BigNumber): Log;
/**** Core Issuance Logs ****/
export declare function SetIssued(_coreAddress: Address, _setAddress: Address, _quantity: BigNumber): Log;
export declare function SetRedeemed(_coreAddress: Address, _setAddress: Address, _quantity: BigNumber): Log;
/**** Core Internal Logs ****/
export declare function FactoryAdded(_coreAddress: Address, _factory: Address): Log;
export declare function FactoryRemoved(_coreAddress: Address, _factory: Address): Log;
export declare function ExchangeAdded(_coreAddress: Address, _exchangeId: BigNumber, _exchange: Address): Log;
export declare function ExchangeRemoved(_coreAddress: Address, _exchangeId: BigNumber): Log;
export declare function ModuleAdded(_coreAddress: Address, _module: Address): Log;
export declare function ModuleRemoved(_coreAddress: Address, _module: Address): Log;
export declare function SetDisabled(_coreAddress: Address, _set: Address): Log;
export declare function SetReenabled(_coreAddress: Address, _set: Address): Log;
export declare function PriceLibraryAdded(_coreAddress: Address, _priceLibrary: Address): Log;
export declare function PriceLibraryRemoved(_coreAddress: Address, _priceLibrary: Address): Log;
export declare function ProtocolFeeRecipientChanged(_coreAddress: Address, _feeRecipient: Address): Log;
export declare function ProtocolFeeChanged(_coreAddress: Address, _sender: Address, _fee: BigNumber): Log;
/********** Other Log Utilities **********/
export declare function extractNewSetTokenAddressFromLogs(logs: Log[]): Address;
export declare function getExpectedTransferLogs(from: Address, to: Address, values: BigNumber[], contractAddresses: Address[]): Log[];
