"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var bignumber_js_1 = require("bignumber.js");
var blockchain_1 = require("../blockchain");
var units_1 = require("../units");
var constants_1 = require("../constants");
var web3Helper_1 = require("../web3Helper");
var coreHelper_1 = require("./coreHelper");
var erc20Helper_1 = require("./erc20Helper");
var set_protocol_oracles_1 = require("set-protocol-oracles");
var feeCalculatorHelper_1 = require("./feeCalculatorHelper");
var liquidatorHelper_1 = require("./liquidatorHelper");
var valuationHelper_1 = require("./valuationHelper");
var web3 = web3Helper_1.getWeb3();
var blockchain = new blockchain_1.Blockchain(web3);
var RebalanceTestSetup = /** @class */ (function () {
    function RebalanceTestSetup(contractOwnerAddress) {
        this._contractOwnerAddress = contractOwnerAddress;
        this._coreHelper = new coreHelper_1.CoreHelper(this._contractOwnerAddress, this._contractOwnerAddress);
        this._erc20Helper = new erc20Helper_1.ERC20Helper(this._contractOwnerAddress);
        this._oracleHelper = new set_protocol_oracles_1.OracleHelper(this._contractOwnerAddress);
        this._feeCalculatorHelper = new feeCalculatorHelper_1.FeeCalculatorHelper(this._contractOwnerAddress);
        this._valuationHelper = new valuationHelper_1.ValuationHelper(this._contractOwnerAddress, this._coreHelper, this._erc20Helper, this._oracleHelper);
        this._liquidatorHelper = new liquidatorHelper_1.LiquidatorHelper(this._contractOwnerAddress, this._erc20Helper, this._valuationHelper);
    }
    /* ============ Deployment ============ */
    RebalanceTestSetup.prototype.initialize = function (from) {
        if (from === void 0) { from = this._contractOwnerAddress; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.initializeCore()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.initializeComponents()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.initializeBaseSets()];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    RebalanceTestSetup.prototype.initializeBaseSets = function (config) {
        if (config === void 0) { config = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        this.set1Components = config.set1Components || [this.component1.address, this.component2.address];
                        this.set1Units = config.set1Units || [new bignumber_js_1.BigNumber(Math.pow(10, 13)), new bignumber_js_1.BigNumber(1280)];
                        this.set1NaturalUnit = config.set1NaturalUnit || new bignumber_js_1.BigNumber(Math.pow(10, 13));
                        _a = this;
                        return [4 /*yield*/, this._coreHelper.createSetTokenAsync(this.core, this.setTokenFactory.address, this.set1Components, this.set1Units, this.set1NaturalUnit)];
                    case 1:
                        _a.set1 = _d.sent();
                        this.set2Components = config.set2Components || [this.component1.address, this.component2.address];
                        this.set2Units = config.set2Units || [new bignumber_js_1.BigNumber(Math.pow(10, 13)), new bignumber_js_1.BigNumber(5120)];
                        this.set2NaturalUnit = config.set2NaturalUnit || new bignumber_js_1.BigNumber(Math.pow(10, 13));
                        _b = this;
                        return [4 /*yield*/, this._coreHelper.createSetTokenAsync(this.core, this.setTokenFactory.address, this.set2Components, this.set2Units, this.set2NaturalUnit)];
                    case 2:
                        _b.set2 = _d.sent();
                        this.set3Components = config.set3Components || [this.component1.address, this.component3.address];
                        this.set3Units = config.set3Units || [new bignumber_js_1.BigNumber(Math.pow(10, 13)), new bignumber_js_1.BigNumber(5120)];
                        this.set3NaturalUnit = config.set3NaturalUnit || new bignumber_js_1.BigNumber(Math.pow(10, 13));
                        _c = this;
                        return [4 /*yield*/, this._coreHelper.createSetTokenAsync(this.core, this.setTokenFactory.address, this.set3Components, this.set3Units, this.set3NaturalUnit)];
                    case 3:
                        _c.set3 = _d.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    RebalanceTestSetup.prototype.initializeComponents = function (config) {
        if (config === void 0) { config = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var component1Decimals, component2Decimals, component3Decimals, _a, _b, _c, _d, _e, _f;
            return __generator(this, function (_g) {
                switch (_g.label) {
                    case 0:
                        component1Decimals = config.component1Decimals || 18;
                        component2Decimals = config.component2Decimals || 6;
                        component3Decimals = config.component3Decimals || 8;
                        _a = this;
                        return [4 /*yield*/, this._erc20Helper.deployTokenAsync(this._contractOwnerAddress, component1Decimals)];
                    case 1:
                        _a.component1 = _g.sent();
                        _b = this;
                        return [4 /*yield*/, this._erc20Helper.deployTokenAsync(this._contractOwnerAddress, component2Decimals)];
                    case 2:
                        _b.component2 = _g.sent();
                        _c = this;
                        return [4 /*yield*/, this._erc20Helper.deployTokenAsync(this._contractOwnerAddress, component3Decimals)];
                    case 3:
                        _c.component3 = _g.sent();
                        this.component1Price = config.component1Price || units_1.ether(128);
                        this.component2Price = config.component2Price || units_1.ether(1);
                        this.component3Price = config.component3Price || units_1.ether(7500);
                        _d = this;
                        return [4 /*yield*/, this._oracleHelper.deployUpdatableOracleMockAsync(this.component1Price)];
                    case 4:
                        _d.component1Oracle = _g.sent();
                        _e = this;
                        return [4 /*yield*/, this._oracleHelper.deployUpdatableOracleMockAsync(this.component2Price)];
                    case 5:
                        _e.component2Oracle = _g.sent();
                        _f = this;
                        return [4 /*yield*/, this._oracleHelper.deployUpdatableOracleMockAsync(this.component3Price)];
                    case 6:
                        _f.component3Oracle = _g.sent();
                        return [4 /*yield*/, this.oracleWhiteList.addTokenOraclePair.sendTransactionAsync(this.component1.address, this.component1Oracle.address)];
                    case 7:
                        _g.sent();
                        return [4 /*yield*/, this.oracleWhiteList.addTokenOraclePair.sendTransactionAsync(this.component2.address, this.component2Oracle.address)];
                    case 8:
                        _g.sent();
                        return [4 /*yield*/, this.oracleWhiteList.addTokenOraclePair.sendTransactionAsync(this.component3.address, this.component3Oracle.address)];
                    case 9:
                        _g.sent();
                        return [4 /*yield*/, this._coreHelper.addTokensToWhiteList([this.component1.address, this.component2.address, this.component3.address], this.rebalancingComponentWhiteList)];
                    case 10:
                        _g.sent();
                        return [4 /*yield*/, this._erc20Helper.approveTransfersAsync([this.component1, this.component2, this.component3], this.transferProxy.address)];
                    case 11:
                        _g.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    RebalanceTestSetup.prototype.initializeCore = function (from) {
        if (from === void 0) { from = this._contractOwnerAddress; }
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, auctionPeriod, rangeStart, rangeEnd, name, _m;
            return __generator(this, function (_o) {
                switch (_o.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, this._coreHelper.deployTransferProxyAsync()];
                    case 1:
                        _a.transferProxy = _o.sent();
                        _b = this;
                        return [4 /*yield*/, this._coreHelper.deployVaultAsync()];
                    case 2:
                        _b.vault = _o.sent();
                        _c = this;
                        return [4 /*yield*/, this._coreHelper.deployCoreMockAsync(this.transferProxy, this.vault)];
                    case 3:
                        _c.core = _o.sent();
                        _d = this;
                        return [4 /*yield*/, this._coreHelper.deploySetTokenFactoryAsync(this.core.address)];
                    case 4:
                        _d.setTokenFactory = _o.sent();
                        return [4 /*yield*/, this._coreHelper.setDefaultStateAndAuthorizationsAsync(this.core, this.vault, this.transferProxy, this.setTokenFactory)];
                    case 5:
                        _o.sent();
                        _e = this;
                        return [4 /*yield*/, this._coreHelper.deployRebalanceAuctionModuleAsync(this.core, this.vault)];
                    case 6:
                        _e.rebalanceAuctionModule = _o.sent();
                        return [4 /*yield*/, this._coreHelper.addModuleAsync(this.core, this.rebalanceAuctionModule.address)];
                    case 7:
                        _o.sent();
                        _f = this;
                        return [4 /*yield*/, this._coreHelper.deployWhiteListAsync()];
                    case 8:
                        _f.rebalancingComponentWhiteList = _o.sent();
                        _g = this;
                        return [4 /*yield*/, this._coreHelper.deployOracleWhiteListAsync()];
                    case 9:
                        _g.oracleWhiteList = _o.sent();
                        _h = this;
                        return [4 /*yield*/, this._coreHelper.deployWhiteListAsync()];
                    case 10:
                        _h.liquidatorWhitelist = _o.sent();
                        _j = this;
                        return [4 /*yield*/, this._coreHelper.deployWhiteListAsync()];
                    case 11:
                        _j.feeCalculatorWhitelist = _o.sent();
                        _k = this;
                        return [4 /*yield*/, this._coreHelper.deployRebalancingSetTokenV3FactoryAsync(this.core.address, this.rebalancingComponentWhiteList.address, this.liquidatorWhitelist.address, this.feeCalculatorWhitelist.address)];
                    case 12:
                        _k.rebalancingFactory = _o.sent();
                        return [4 /*yield*/, this._coreHelper.addFactoryAsync(this.core, this.rebalancingFactory)];
                    case 13:
                        _o.sent();
                        _l = this;
                        return [4 /*yield*/, this._feeCalculatorHelper.deployFixedFeeCalculatorAsync()];
                    case 14:
                        _l.fixedFeeCalculator = _o.sent();
                        return [4 /*yield*/, this._coreHelper.addAddressToWhiteList(this.fixedFeeCalculator.address, this.feeCalculatorWhitelist)];
                    case 15:
                        _o.sent();
                        auctionPeriod = constants_1.ONE_HOUR_IN_SECONDS.mul(4);
                        rangeStart = new bignumber_js_1.BigNumber(1);
                        rangeEnd = new bignumber_js_1.BigNumber(21);
                        name = 'liquidator';
                        _m = this;
                        return [4 /*yield*/, this._liquidatorHelper.deployLinearAuctionLiquidatorAsync(this.core.address, this.oracleWhiteList.address, auctionPeriod, rangeStart, rangeEnd, name)];
                    case 16:
                        _m.linearAuctionLiquidator = _o.sent();
                        return [4 /*yield*/, this._coreHelper.addAddressToWhiteList(this.linearAuctionLiquidator.address, this.liquidatorWhitelist)];
                    case 17:
                        _o.sent();
                        console.log('Core: ' + this.core.address, 'TransferProxy: ' + this.transferProxy.address, 'Vault: ' + this.vault.address, 'SetTokenFactory: ' + this.setTokenFactory.address, 'RebalanceAuctionModule: ' + this.rebalanceAuctionModule.address, 'RebalancingComponentWhiteList: ' + this.rebalancingComponentWhiteList.address, 'OracleWhiteList: ' + this.oracleWhiteList.address, 'LiquidatorWhiteList: ' + this.liquidatorWhitelist.address, 'FeeCalculatorWhiteList: ' + this.feeCalculatorWhitelist.address, 'RebalancingFactory: ' + this.rebalancingFactory.address, 'FixedFeeCalculator: ' + this.fixedFeeCalculator.address, 'LinearAuctionLiquidator: ' + this.linearAuctionLiquidator.address);
                        return [2 /*return*/];
                }
            });
        });
    };
    RebalanceTestSetup.prototype.setRebalancingSet = function (rebalancingSet) {
        this.rebalancingSetToken = rebalancingSet;
    };
    RebalanceTestSetup.prototype.mintRebalancingSets = function (rebalancingSetQuantity) {
        return __awaiter(this, void 0, void 0, function () {
            var rebalancingNaturalUnit, currentSet, currentSetUnit, curSetNaturalUnit, currentSetRequired, currentSetERC20Instance;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.rebalancingSetToken.naturalUnit.callAsync()];
                    case 1:
                        rebalancingNaturalUnit = _a.sent();
                        return [4 /*yield*/, this.rebalancingSetToken.currentSet.callAsync()];
                    case 2:
                        currentSet = _a.sent();
                        return [4 /*yield*/, this.rebalancingSetToken.getUnits.callAsync()];
                    case 3:
                        currentSetUnit = (_a.sent())[0];
                        return [4 /*yield*/, this.set1.naturalUnit.callAsync()];
                    case 4:
                        curSetNaturalUnit = _a.sent();
                        currentSetRequired = rebalancingSetQuantity
                            .mul(currentSetUnit)
                            .div(rebalancingNaturalUnit)
                            .div(curSetNaturalUnit).round(0, 3)
                            .mul(curSetNaturalUnit)
                            .mul(2);
                        // Issue currentSetToken
                        return [4 /*yield*/, this.core.issue.sendTransactionAsync(currentSet, currentSetRequired, { from: this._contractOwnerAddress })];
                    case 5:
                        // Issue currentSetToken
                        _a.sent();
                        return [4 /*yield*/, this._erc20Helper.getTokenInstanceAsync(currentSet)];
                    case 6:
                        currentSetERC20Instance = _a.sent();
                        return [4 /*yield*/, this._erc20Helper.approveTransfersAsync([currentSetERC20Instance], this.transferProxy.address)];
                    case 7:
                        _a.sent();
                        // Use issued currentSetToken to issue rebalancingSetToken
                        return [4 /*yield*/, this.core.issue.sendTransactionAsync(this.rebalancingSetToken.address, rebalancingSetQuantity)];
                    case 8:
                        // Use issued currentSetToken to issue rebalancingSetToken
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    RebalanceTestSetup.prototype.approveComponentsToAddress = function (toApprove) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._erc20Helper.approveTransfersAsync([this.component1, this.component2, this.component3], toApprove)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    RebalanceTestSetup.prototype.jumpTimeAndUpdateOracles = function (timeIncrease, newPrices) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, blockchain.increaseTimeAsync(timeIncrease)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, blockchain.mineBlockAsync()];
                    case 2:
                        _a.sent();
                        if (!newPrices.component1Price) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.component1Oracle.updatePrice.sendTransactionAsync(newPrices.component1Price)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        if (!newPrices.component2Price) return [3 /*break*/, 6];
                        return [4 /*yield*/, this.component2Oracle.updatePrice.sendTransactionAsync(newPrices.component2Price)];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6:
                        if (!newPrices.component3Price) return [3 /*break*/, 8];
                        return [4 /*yield*/, this.component3Oracle.updatePrice.sendTransactionAsync(newPrices.component3Price)];
                    case 7:
                        _a.sent();
                        _a.label = 8;
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    return RebalanceTestSetup;
}());
exports.RebalanceTestSetup = RebalanceTestSetup;
