"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.CompoundUtils={contractName:"CompoundUtils",abi:[],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[],"devdoc":{"author":"Set Protocol * Collection of common Compound functions for use in Set Protocol contracts","methods":{},"title":"CompoundUtils"},"userdoc":{"methods":{}}},"settings":{"compilationTarget":{"set-protocol-contract-utils/contracts/lib/CompoundUtils.sol":"CompoundUtils"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"openzeppelin-solidity/contracts/math/SafeMath.sol":{"keccak256":"0xc2a200a877c4a9b2475c246c54ffecc69ffde3e11af83319c63c2dc5458bac80","urls":["bzzr://c8876e2c39b60f155d748d71d715c8f3903fae5a405ac599adcb6ad2f9a583f9"]},"set-protocol-contract-utils/contracts/lib/CommonMath.sol":{"keccak256":"0x3d1d08c6efc2a973fe2c02ddcb02fd99a8c8eb75f74dcbd93e8e15864eee2b6b","urls":["bzzr://580815dd1cf648a4521d923e59087de21143d9c48115ab71579a1f5a8f3d36af"]},"set-protocol-contract-utils/contracts/lib/CompoundUtils.sol":{"keccak256":"0x2fae8240526a689d919a67792626c9df1e8048a59eed6643ff4ce685a87a36dc","urls":["bzzr://5a5709236aaa10d93f1746e765fd4e10693277f5cbc3e24d5173738f87a01072"]}},"version":1}',bytecode:"0x604c6023600b82828239805160001a607314601657fe5b30600052607381538281f3fe73000000000000000000000000000000000000000030146080604052600080fdfea165627a7a72305820d5d1d9f02843d42201069b5efb4ad0eeebd9e5a8d2696d0c514158566d7e62f30029",deployedBytecode:"0x73000000000000000000000000000000000000000030146080604052600080fdfea165627a7a72305820d5d1d9f02843d42201069b5efb4ad0eeebd9e5a8d2696d0c514158566d7e62f30029",sourceMap:"884:890:178:-;;132:2:-1;166:7;155:9;146:7;137:37;255:7;249:14;246:1;241:23;235:4;232:33;222:2;;269:9;222:2;293:9;290:1;283:20;323:4;314:7;306:22;347:7;338;331:24",deployedSourceMap:"884:890:178:-;;;;;;;;",source:'/*\n    Copyright 2020 Set Labs Inc.\n\n    Licensed under the Apache License, Version 2.0 (the "License");\n    you may not use this file except in compliance with the License.\n    You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n    Unless required by applicable law or agreed to in writing, software\n    distributed under the License is distributed on an "AS IS" BASIS,\n    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n    See the License for the specific language governing permissions and\n    limitations under the License.\n*/\n\npragma solidity 0.5.7;\n\nimport { SafeMath } from "openzeppelin-solidity/contracts/math/SafeMath.sol";\nimport { CommonMath } from "./CommonMath.sol";\n\n\n/**\n * @title CompoundUtils\n * @author Set Protocol\n *\n * Collection of common Compound functions for use in Set Protocol contracts\n */\nlibrary CompoundUtils\n{\n    using SafeMath for uint256;\n\n    /*\n     * Utility function to convert a specified amount of cTokens to underlying \n     * token based on the cToken\'s exchange rate\n     *\n     * @param _cTokenAmount         Amount of cTokens that will be converted to underlying\n     * @param _cTokenExchangeRate   Exchange rate for the cToken\n     * @return underlyingAmount     Amount of underlying ERC20 tokens\n     */\n    function convertCTokenToUnderlying(\n        uint256 _cTokenAmount,\n        uint256 _cTokenExchangeRate\n    )\n    internal\n    pure\n    returns (uint256)\n    {\n        // Underlying units is calculated as cToken quantity * exchangeRate divided by 10 ** 18 and rounded up.\n        uint256 a = _cTokenAmount.mul(_cTokenExchangeRate);\n        uint256 b = CommonMath.scaleFactor();\n\n        // Round value up\n        return CommonMath.divCeil(a, b);\n    }\n}',sourcePath:"set-protocol-contract-utils/contracts/lib/CompoundUtils.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.567Z",devdoc:{author:"Set Protocol * Collection of common Compound functions for use in Set Protocol contracts",methods:{},title:"CompoundUtils"},userdoc:{methods:{}}};