"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ExchangeHeaderLibrary={contractName:"ExchangeHeaderLibrary",abi:[],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[],"devdoc":{"author":"Set Protocol * This library contains functions and structs to assist with parsing exchange orders data","methods":{},"title":"ExchangeHeaderLibrary"},"userdoc":{"methods":{}}},"settings":{"compilationTarget":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/lib/ExchangeHeaderLibrary.sol":"ExchangeHeaderLibrary"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/lib/ExchangeHeaderLibrary.sol":{"keccak256":"0x58b3405fe4aab096766b34705ec80d87085180110e21aba02cce2e6ea507d808","urls":["bzzr://0b6941c5bdb138ebe0080bbe5f6c43e56878e0bc30ff3c2461f0e3b53b8a6113"]},"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/LibBytes.sol":{"keccak256":"0x8617740051ffe434ec5737fa1cf53fdd3c6dd901d6f8c3b379754d9928daa752","urls":["bzzr://52865a32d5c247782bf2fda7bb606c579caa924875108b96d7ea388ef19991fc"]},"openzeppelin-solidity/contracts/math/SafeMath.sol":{"keccak256":"0xc2a200a877c4a9b2475c246c54ffecc69ffde3e11af83319c63c2dc5458bac80","urls":["bzzr://c8876e2c39b60f155d748d71d715c8f3903fae5a405ac599adcb6ad2f9a583f9"]}},"version":1}',bytecode:"0x605a6023600b82828239805160001a607314601657fe5b30600052607381538281f3fe73000000000000000000000000000000000000000030146080604052600080fdfea265627a7a7230582011e31788125e754ce2a02c2367f5b3bcdd6fead5bbdc52a2753b48deeb1d6abe6c6578706572696d656e74616cf50037",deployedBytecode:"0x73000000000000000000000000000000000000000030146080604052600080fdfea265627a7a7230582011e31788125e754ce2a02c2367f5b3bcdd6fead5bbdc52a2753b48deeb1d6abe6c6578706572696d656e74616cf50037",sourceMap:"955:2226:40:-;;132:2:-1;166:7;155:9;146:7;137:37;255:7;249:14;246:1;241:23;235:4;232:33;222:2;;269:9;222:2;293:9;290:1;283:20;323:4;314:7;306:22;347:7;338;331:24",deployedSourceMap:"955:2226:40:-;;;;;;;;",source:'/*\n    Copyright 2018 Set Labs Inc.\n\n    Licensed under the Apache License, Version 2.0 (the "License");\n    you may not use this file except in compliance with the License.\n    You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n    Unless required by applicable law or agreed to in writing, software\n    distributed under the License is distributed on an "AS IS" BASIS,\n    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n    See the License for the specific language governing permissions and\n    limitations under the License.\n*/\n\npragma solidity 0.5.7;\npragma experimental "ABIEncoderV2";\n\nimport { SafeMath } from "openzeppelin-solidity/contracts/math/SafeMath.sol";\n\nimport { LibBytes } from "../../external/0x/LibBytes.sol";\n\n\n/**\n * @title ExchangeHeaderLibrary\n * @author Set Protocol\n *\n * This library contains functions and structs to assist with parsing exchange orders data\n */\nlibrary ExchangeHeaderLibrary {\n    using LibBytes for bytes;\n    using SafeMath for uint256;\n\n    // ============ Structs ============\n\n    struct ExchangeHeader {\n        uint8 exchange;\n        uint8 orderCount;\n        uint256 orderDataBytesLength;\n    }\n\n    function EXCHANGE_HEADER_LENGTH()\n        internal\n        pure\n        returns (uint256)\n    {\n        return uint256(96);\n    }\n\n    // ============ Internal Functions ============\n\n    /**\n     * Function to convert bytes into ExchangeHeader\n     *\n     * @param _orderData        Bytes representing the order body information\n     * @param _offset           Bytes to offset orderData by\n     * @return ExchangeHeader   Struct containing data for a batch of exchange orders\n     */\n    function parseExchangeHeader(\n        bytes memory _orderData,\n        uint256 _offset\n    )\n        internal\n        pure\n        returns (ExchangeHeader memory)\n    {\n        ExchangeHeader memory header;\n\n        uint256 headerDataStart = _orderData.contentAddress().add(_offset);\n\n        assembly {\n            mstore(header,          mload(headerDataStart))            // exchange\n            mstore(add(header, 32), mload(add(headerDataStart, 32)))   // orderCount\n            mstore(add(header, 64), mload(add(headerDataStart, 64)))   // orderDataBytesLength\n        }\n\n        return header;\n    }\n\n    /**\n     * Function to extract the exchange body from the order data\n     *\n     * @param _orderData                Bytes representing the exchange order information\n     * @param _scannedBytes             Number representing the number of bytes already processed\n     * @param _exchangeDataLength       Length of the exchange data from the exchange data header\n     * @return ExchangeBody  Bytes representing the exchange body\n     */\n    function sliceBodyData(\n        bytes memory _orderData,\n        uint256 _scannedBytes,\n        uint256 _exchangeDataLength\n    )\n        internal\n        pure\n        returns (bytes memory)\n    {\n        bytes memory bodyData = LibBytes.slice(\n            _orderData,\n            _scannedBytes.add(EXCHANGE_HEADER_LENGTH()),\n            _scannedBytes.add(_exchangeDataLength)\n        );\n\n        return bodyData;\n    }\n}\n',sourcePath:"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/lib/ExchangeHeaderLibrary.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.233Z",devdoc:{author:"Set Protocol * This library contains functions and structs to assist with parsing exchange orders data",methods:{},title:"ExchangeHeaderLibrary"},userdoc:{methods:{}}};