"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ExchangeIssuanceLibrary={contractName:"ExchangeIssuanceLibrary",abi:[],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[],"devdoc":{"author":"Set Protocol * The ExchangeIssuanceLibrary contains functions for validating exchange order data","methods":{},"title":"ExchangeIssuanceLibrary"},"userdoc":{"methods":{}}},"settings":{"compilationTarget":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/modules/lib/ExchangeIssuanceLibrary.sol":"ExchangeIssuanceLibrary"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/ICore.sol":{"keccak256":"0x5dc3db4398630ea52d2a40c9ddfa89d94e65c2770a12bab4d2a5c8eb573fb0a0","urls":["bzzr://25e90b53f61b388e0950b808e2296f82d427b66cfd6021212713436b2a592e31"]},"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/ISetToken.sol":{"keccak256":"0xfa6c0c07f8394d89b6b8f72e15778f8452a9341acb20cebb8421f3522aaca1bd","urls":["bzzr://ccf23bb78fd507bf8cbf5cf7ac2a660a1463b87a3689196e42b8f6862d1a6b11"]},"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/IVault.sol":{"keccak256":"0xf8a6d376173be39f5744492866db5dd3f91453a124d23679ff164ff3817f2f4f","urls":["bzzr://896c0a8329175c1620e1a22467778b835defe0e61847e5a8427a306f42391e64"]},"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/modules/lib/ExchangeIssuanceLibrary.sol":{"keccak256":"0xad04bacfe5bb25a8cb0ca84f3a406e9c10a45e75c13ebdf24f27801399b2cbeb","urls":["bzzr://f6a28d02f730cfb64f3082d7cb2780cbb07c8939648f7466d21eae21defa6367"]},"openzeppelin-solidity/contracts/math/SafeMath.sol":{"keccak256":"0xc2a200a877c4a9b2475c246c54ffecc69ffde3e11af83319c63c2dc5458bac80","urls":["bzzr://c8876e2c39b60f155d748d71d715c8f3903fae5a405ac599adcb6ad2f9a583f9"]},"set-protocol-contract-utils/contracts/lib/AddressArrayUtils.sol":{"keccak256":"0xb716eab4e8c5a336a2f19078928530829af097912bd1b925644f914b63601f08","urls":["bzzr://d8a21d39779beb316adb5180d08dcba1941eeccd9412ff08feb21a631c18c269"]}},"version":1}',bytecode:"0x604c6023600b82828239805160001a607314601657fe5b30600052607381538281f3fe73000000000000000000000000000000000000000030146080604052600080fdfea165627a7a72305820f4f11c261bfd3f1f0e3b4c128195923c6197fb7a65067f9f32750399848afc930029",deployedBytecode:"0x73000000000000000000000000000000000000000030146080604052600080fdfea165627a7a72305820f4f11c261bfd3f1f0e3b4c128195923c6197fb7a65067f9f32750399848afc930029",sourceMap:"1123:5959:68:-;;132:2:-1;166:7;155:9;146:7;137:37;255:7;249:14;246:1;241:23;235:4;232:33;222:2;;269:9;222:2;293:9;290:1;283:20;323:4;314:7;306:22;347:7;338;331:24",deployedSourceMap:"1123:5959:68:-;;;;;;;;",source:'/*\n    Copyright 2018 Set Labs Inc.\n\n    Licensed under the Apache License, Version 2.0 (the "License");\n    you may not use this file except in compliance with the License.\n    You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n    Unless required by applicable law or agreed to in writing, software\n    distributed under the License is distributed on an "AS IS" BASIS,\n    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n    See the License for the specific language governing permissions and\n    limitations under the License.\n*/\n\npragma solidity 0.5.7;\n\nimport { SafeMath } from "openzeppelin-solidity/contracts/math/SafeMath.sol";\nimport { AddressArrayUtils } from "set-protocol-contract-utils/contracts/lib/AddressArrayUtils.sol";\n\nimport { ICore } from "../../interfaces/ICore.sol";\nimport { ISetToken } from "../../interfaces/ISetToken.sol";\nimport { IVault } from "../../interfaces/IVault.sol";\n\n\n/**\n * @title ExchangeIssuanceLibrary\n * @author Set Protocol\n *\n * The ExchangeIssuanceLibrary contains functions for validating exchange order data\n */\nlibrary ExchangeIssuanceLibrary {\n    using SafeMath for uint256;\n    using AddressArrayUtils for address[];\n\n    // ============ Structs ============\n\n    struct ExchangeIssuanceParams {\n        address setAddress;\n        uint256 quantity;\n        uint8[] sendTokenExchangeIds;\n        address[] sendTokens;\n        uint256[] sendTokenAmounts;\n        address[] receiveTokens;\n        uint256[] receiveTokenAmounts;\n    }\n\n    /**\n     * Validates that the quantity to issue is positive and a multiple of the Set natural unit.\n     *\n     * @param _set                The address of the Set\n     * @param _quantity           The quantity of Sets to issue or redeem\n     */\n    function validateQuantity(\n        address _set,\n        uint256 _quantity\n    )\n        internal\n        view\n    {\n        // Make sure quantity to issue is greater than 0\n        require(\n            _quantity > 0,\n            "ExchangeIssuanceLibrary.validateQuantity: Quantity must be positive"\n        );\n\n        // Make sure Issue quantity is multiple of the Set natural unit\n        require(\n            _quantity.mod(ISetToken(_set).naturalUnit()) == 0,\n            "ExchangeIssuanceLibrary.validateQuantity: Quantity must be multiple of natural unit"\n        );\n    }\n\n    /**\n     * Validates that the required Components and amounts are valid components and positive.\n     * Duplicate receive token values are not allowed\n     *\n     * @param _receiveTokens           The addresses of components required for issuance\n     * @param _receiveTokenAmounts     The quantities of components required for issuance\n     */\n    function validateReceiveTokens(\n        address[] memory _receiveTokens,\n        uint256[] memory _receiveTokenAmounts\n    )\n        internal\n        view\n    {\n        uint256 receiveTokensCount = _receiveTokens.length;\n\n        // Make sure required components array is non-empty\n        require(\n            receiveTokensCount > 0,\n            "ExchangeIssuanceLibrary.validateReceiveTokens: Receive tokens must not be empty"\n        );\n\n        // Ensure the receive tokens has no duplicates\n        require(\n            !_receiveTokens.hasDuplicate(),\n            "ExchangeIssuanceLibrary.validateReceiveTokens: Receive tokens must not have duplicates"\n        );\n\n        // Make sure required components and required component amounts are equal length\n        require(\n            receiveTokensCount == _receiveTokenAmounts.length,\n            "ExchangeIssuanceLibrary.validateReceiveTokens: Receive tokens and amounts must be equal length"\n        );\n\n        for (uint256 i = 0; i < receiveTokensCount; i++) {\n            // Make sure all required component amounts are non-zero\n            require(\n                _receiveTokenAmounts[i] > 0,\n                "ExchangeIssuanceLibrary.validateReceiveTokens: Component amounts must be positive"\n            );\n        }\n    }\n\n    /**\n     * Validates that the tokens received exceeds what we expect\n     *\n     * @param _vault                        The address of the Vault\n     * @param _receiveTokens                The addresses of components required for issuance\n     * @param _requiredBalances             The quantities of components required for issuance\n     * @param _userToCheck                  The address of the user\n     */\n    function validatePostExchangeReceiveTokenBalances(\n        address _vault,\n        address[] memory _receiveTokens,\n        uint256[] memory _requiredBalances,\n        address _userToCheck\n    )\n        internal\n        view\n    {\n        // Get vault instance\n        IVault vault = IVault(_vault);\n\n        // Check that caller\'s receive tokens in Vault have been incremented correctly\n        for (uint256 i = 0; i < _receiveTokens.length; i++) {\n            uint256 currentBal = vault.getOwnerBalance(\n                _receiveTokens[i],\n                _userToCheck\n            );\n\n            require(\n                currentBal >= _requiredBalances[i],\n                "ExchangeIssuanceLibrary.validatePostExchangeReceiveTokenBalances: Insufficient receive token acquired"\n            );\n        }\n    }\n\n    /**\n     * Validates that the send tokens inputs are valid. Since tokens are sent to various exchanges,\n     * duplicate send tokens are valid\n     *\n     * @param _core                         The address of Core\n     * @param _sendTokenExchangeIds         List of exchange wrapper enumerations corresponding to \n     *                                          the wrapper that will handle the component\n     * @param _sendTokens                   The address of the send tokens\n     * @param _sendTokenAmounts             The quantities of send tokens\n     */\n    function validateSendTokenParams(\n        address _core,\n        uint8[] memory _sendTokenExchangeIds,\n        address[] memory _sendTokens,\n        uint256[] memory _sendTokenAmounts\n    )\n        internal\n        view\n    {\n        require(\n            _sendTokens.length > 0,\n            "ExchangeIssuanceLibrary.validateSendTokenParams: Send token inputs must not be empty"\n        );\n\n        require(\n            _sendTokenExchangeIds.length == _sendTokens.length && \n            _sendTokens.length == _sendTokenAmounts.length,\n            "ExchangeIssuanceLibrary.validateSendTokenParams: Send token inputs must be of the same length"\n        );\n\n        ICore core = ICore(_core);\n\n        for (uint256 i = 0; i < _sendTokenExchangeIds.length; i++) {\n            // Make sure all exchanges are valid\n            require(\n                core.exchangeIds(_sendTokenExchangeIds[i]) != address(0),\n                "ExchangeIssuanceLibrary.validateSendTokenParams: Must be valid exchange"\n            );\n\n            // Make sure all send token amounts are non-zero\n            require(\n                _sendTokenAmounts[i] > 0,\n                "ExchangeIssuanceLibrary.validateSendTokenParams: Send amounts must be positive"\n            );\n        }\n    }\n}\n',sourcePath:"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/modules/lib/ExchangeIssuanceLibrary.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.347Z",devdoc:{author:"Set Protocol * The ExchangeIssuanceLibrary contains functions for validating exchange order data",methods:{},title:"ExchangeIssuanceLibrary"},userdoc:{methods:{}}};