"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.IAddressToAddressWhiteList={contractName:"IAddressToAddressWhiteList",abi:[{constant:true,inputs:[{name:"_key",type:"address"}],name:"whitelist",outputs:[{name:"",type:"address"}],payable:false,stateMutability:"view",type:"function"},{constant:true,inputs:[{name:"_keys",type:"address[]"}],name:"areValidAddresses",outputs:[{name:"",type:"bool"}],payable:false,stateMutability:"view",type:"function"},{constant:true,inputs:[{name:"_key",type:"address[]"}],name:"getValues",outputs:[{name:"",type:"address[]"}],payable:false,stateMutability:"view",type:"function"},{constant:true,inputs:[{name:"_key",type:"address"}],name:"getValue",outputs:[{name:"",type:"address"}],payable:false,stateMutability:"view",type:"function"},{constant:true,inputs:[],name:"validAddresses",outputs:[{name:"",type:"address[]"}],payable:false,stateMutability:"view",type:"function"}],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[{"constant":true,"inputs":[{"name":"_key","type":"address[]"}],"name":"getValues","outputs":[{"name":"","type":"address[]"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"_keys","type":"address[]"}],"name":"areValidAddresses","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"_key","type":"address"}],"name":"getValue","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"_key","type":"address"}],"name":"whitelist","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"validAddresses","outputs":[{"name":"","type":"address[]"}],"payable":false,"stateMutability":"view","type":"function"}],"devdoc":{"author":"Set Protocol * The IAddressToAddressWhiteList interface exposes the whitelist mapping to check components","methods":{"areValidAddresses(address[])":{"params":{"_keys":"Array of key type addresses to check if value exists"},"return":"bool                 Whether all addresses in the list are whitelisted"},"getValue(address)":{"params":{"_key":"Address of key type"},"return":"address            Address associated with _key "},"getValues(address[])":{"params":{"_key":"Array of key type addresses to get value type addresses for"},"return":"address[]           Array of value type addresses"},"validAddresses()":{"return":"address[]      Array of key type addresses"},"whitelist(address)":{"params":{"_key":"Address to check"},"return":"bool                Whether passed in address is whitelisted"}},"title":"IAddressToAddressWhiteList"},"userdoc":{"methods":{"areValidAddresses(address[])":{"notice":"Verifies an array of addresses against the whitelist"},"getValue(address)":{"notice":"Return value type address associated with a passed key type address "},"getValues(address[])":{"notice":"Return array of value type addresses based on passed in key type addresses "},"validAddresses()":{"notice":"Return array of all whitelisted addresses"},"whitelist(address)":{"notice":"Returns value of key type address passed in (not in array form)"}}}},"settings":{"compilationTarget":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/IAddressToAddressWhiteList.sol":"IAddressToAddressWhiteList"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/IAddressToAddressWhiteList.sol":{"keccak256":"0x41d753215ef7bdf88734589bd55afdb524722d1e34589ab8194f5b64f95fa455","urls":["bzzr://b6a819b457dddc2c2aa4d23fb2eb5ea27cbd6994a7361e7ced7e8e89e7552a88"]}},"version":1}',bytecode:"0x",deployedBytecode:"0x",sourceMap:"",deployedSourceMap:"",source:'/*\n    Copyright 2020 Set Labs Inc.\n\n    Licensed under the Apache License, Version 2.0 (the "License");\n    you may not use this file except in compliance with the License.\n    You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n    Unless required by applicable law or agreed to in writing, software\n    distributed under the License is distributed on an "AS IS" BASIS,\n    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n    See the License for the specific language governing permissions and\n    limitations under the License.\n*/\n\npragma solidity 0.5.7;\n\n/**\n * @title IAddressToAddressWhiteList\n * @author Set Protocol\n *\n * The IAddressToAddressWhiteList interface exposes the whitelist mapping to check components\n */\ninterface IAddressToAddressWhiteList {\n\n    /* ============ External Functions ============ */\n\n    /**\n     * Returns value of key type address passed in (not in array form)\n     *\n     * @param  _key     Address to check\n     * @return bool                Whether passed in address is whitelisted\n     */\n    function whitelist(\n        address _key\n    )\n        external\n        view\n        returns (address);\n\n    /**\n     * Verifies an array of addresses against the whitelist\n     *\n     * @param  _keys                Array of key type addresses to check if value exists\n     * @return bool                 Whether all addresses in the list are whitelisted\n     */\n    function areValidAddresses(\n        address[] calldata _keys\n    )\n        external\n        view\n        returns (bool);\n\n    /**\n     * Return array of value type addresses based on passed in key type addresses \n     *\n     * @param  _key                Array of key type addresses to get value type addresses for\n     * @return address[]           Array of value type addresses\n     */\n    function getValues(\n        address[] calldata _key\n    )\n        external\n        view\n        returns (address[] memory);\n\n    /**\n     * Return value type address associated with a passed key type address \n     *\n     * @param  _key               Address of key type\n     * @return address            Address associated with _key \n     */\n    function getValue(\n        address _key\n    )\n        external\n        view\n        returns (address);\n\n    /**\n     * Return array of all whitelisted addresses\n     *\n     * @return address[]      Array of key type addresses\n     */\n    function validAddresses()\n        external\n        view\n        returns (address[] memory);\n}\n',sourcePath:"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/IAddressToAddressWhiteList.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.178Z",devdoc:{author:"Set Protocol * The IAddressToAddressWhiteList interface exposes the whitelist mapping to check components",methods:{"areValidAddresses(address[])":{params:{_keys:"Array of key type addresses to check if value exists"},"return":"bool                 Whether all addresses in the list are whitelisted"},"getValue(address)":{params:{_key:"Address of key type"},"return":"address            Address associated with _key "},"getValues(address[])":{params:{_key:"Array of key type addresses to get value type addresses for"},"return":"address[]           Array of value type addresses"},"validAddresses()":{"return":"address[]      Array of key type addresses"},"whitelist(address)":{params:{_key:"Address to check"},"return":"bool                Whether passed in address is whitelisted"}},title:"IAddressToAddressWhiteList"},userdoc:{methods:{"areValidAddresses(address[])":{notice:"Verifies an array of addresses against the whitelist"},"getValue(address)":{notice:"Return value type address associated with a passed key type address "},"getValues(address[])":{notice:"Return array of value type addresses based on passed in key type addresses "},"validAddresses()":{notice:"Return array of all whitelisted addresses"},"whitelist(address)":{notice:"Returns value of key type address passed in (not in array form)"}}}};