"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.IAssetProxy={contractName:"IAssetProxy",abi:[{constant:false,inputs:[{name:"target",type:"address"}],name:"addAuthorizedAddress",outputs:[],payable:false,stateMutability:"nonpayable",type:"function"},{constant:false,inputs:[{name:"target",type:"address"}],name:"removeAuthorizedAddress",outputs:[],payable:false,stateMutability:"nonpayable",type:"function"},{constant:false,inputs:[{name:"target",type:"address"},{name:"index",type:"uint256"}],name:"removeAuthorizedAddressAtIndex",outputs:[],payable:false,stateMutability:"nonpayable",type:"function"},{constant:true,inputs:[],name:"getAuthorizedAddresses",outputs:[{name:"",type:"address[]"}],payable:false,stateMutability:"view",type:"function"},{constant:false,inputs:[{name:"newOwner",type:"address"}],name:"transferOwnership",outputs:[],payable:false,stateMutability:"nonpayable",type:"function"},{constant:false,inputs:[{name:"assetData",type:"bytes"},{name:"from",type:"address"},{name:"to",type:"address"},{name:"amount",type:"uint256"}],name:"transferFrom",outputs:[],payable:false,stateMutability:"nonpayable",type:"function"},{constant:true,inputs:[],name:"getProxyId",outputs:[{name:"",type:"bytes4"}],payable:false,stateMutability:"view",type:"function"}],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[{"constant":false,"inputs":[{"name":"target","type":"address"}],"name":"addAuthorizedAddress","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"target","type":"address"}],"name":"removeAuthorizedAddress","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"target","type":"address"},{"name":"index","type":"uint256"}],"name":"removeAuthorizedAddressAtIndex","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"assetData","type":"bytes"},{"name":"from","type":"address"},{"name":"to","type":"address"},{"name":"amount","type":"uint256"}],"name":"transferFrom","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"getProxyId","outputs":[{"name":"","type":"bytes4"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"getAuthorizedAddresses","outputs":[{"name":"","type":"address[]"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"newOwner","type":"address"}],"name":"transferOwnership","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"}],"devdoc":{"methods":{"addAuthorizedAddress(address)":{"details":"Authorizes an address.","params":{"target":"Address to authorize."}},"getAuthorizedAddresses()":{"details":"Gets all authorized addresses.","return":"Array of authorized addresses."},"getProxyId()":{"details":"Gets the proxy id associated with the proxy address.","return":"Proxy id."},"removeAuthorizedAddress(address)":{"details":"Removes authorizion of an address.","params":{"target":"Address to remove authorization from."}},"removeAuthorizedAddressAtIndex(address,uint256)":{"details":"Removes authorizion of an address.","params":{"index":"Index of target in authorities array.","target":"Address to remove authorization from."}},"transferFrom(bytes,address,address,uint256)":{"details":"Transfers assets. Either succeeds or throws.","params":{"amount":"Amount of asset to transfer.","assetData":"Byte array encoded for the respective asset proxy.","from":"Address to transfer asset from.","to":"Address to transfer asset to."}}}},"userdoc":{"methods":{}}},"settings":{"compilationTarget":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/AssetProxy/interfaces/IAssetProxy.sol":"IAssetProxy"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/AssetProxy/interfaces/IAssetProxy.sol":{"keccak256":"0x9f8831238f6e270a86a5412cade57289dc479c4bd84d0cad79656661136a23e9","urls":["bzzr://c6df28ab3d0f930059861a6dd001b9a1977d6b4b47d0e4313a30bec6bcc4c7dc"]},"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/AssetProxy/interfaces/IAuthorizable.sol":{"keccak256":"0xb65b9b719b412c54b78a5b475d202da4618d86944cf595e0c47e13ad1c32745e","urls":["bzzr://e1fac619754c329e809cb15bc4db300632dc8ad8e67cf0ab8029dccf00023ad9"]}},"version":1}',bytecode:"0x",deployedBytecode:"0x",sourceMap:"",deployedSourceMap:"",source:'/*\n\n  Copyright 2018 ZeroEx Intl.\n\n  Licensed under the Apache License, Version 2.0 (the "License");\n  you may not use this file except in compliance with the License.\n  You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n  Unless required by applicable law or agreed to in writing, software\n  distributed under the License is distributed on an "AS IS" BASIS,\n  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  See the License for the specific language governing permissions and\n  limitations under the License.\n\n*/\n\npragma solidity 0.5.7;\npragma experimental ABIEncoderV2;\n\nimport "./IAuthorizable.sol";\n\ncontract IAssetProxy is\n    IAuthorizable\n{\n\n    /// @dev Transfers assets. Either succeeds or throws.\n    /// @param assetData Byte array encoded for the respective asset proxy.\n    /// @param from Address to transfer asset from.\n    /// @param to Address to transfer asset to.\n    /// @param amount Amount of asset to transfer.\n    function transferFrom(\n        bytes calldata assetData,\n        address from,\n        address to,\n        uint256 amount\n    )\n        external;\n\n    /// @dev Gets the proxy id associated with the proxy address.\n    /// @return Proxy id.\n    function getProxyId()\n        external\n        view\n        returns (bytes4);\n}\n',sourcePath:"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/AssetProxy/interfaces/IAssetProxy.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.447Z",devdoc:{methods:{"addAuthorizedAddress(address)":{details:"Authorizes an address.",params:{target:"Address to authorize."}},"getAuthorizedAddresses()":{details:"Gets all authorized addresses.","return":"Array of authorized addresses."},"getProxyId()":{details:"Gets the proxy id associated with the proxy address.","return":"Proxy id."},"removeAuthorizedAddress(address)":{details:"Removes authorizion of an address.",params:{target:"Address to remove authorization from."}},"removeAuthorizedAddressAtIndex(address,uint256)":{details:"Removes authorizion of an address.",params:{index:"Index of target in authorities array.",target:"Address to remove authorization from."}},"transferFrom(bytes,address,address,uint256)":{details:"Transfers assets. Either succeeds or throws.",params:{amount:"Amount of asset to transfer.",assetData:"Byte array encoded for the respective asset proxy.",from:"Address to transfer asset from.",to:"Address to transfer asset to."}}}},userdoc:{methods:{}}};