"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.IAssetProxyDispatcher={contractName:"IAssetProxyDispatcher",abi:[{constant:false,inputs:[{name:"assetProxyId",type:"bytes4"},{name:"newAssetProxy",type:"address"},{name:"oldAssetProxy",type:"address"}],name:"registerAssetProxy",outputs:[],payable:false,stateMutability:"nonpayable",type:"function"},{constant:true,inputs:[{name:"assetProxyId",type:"bytes4"}],name:"getAssetProxy",outputs:[{name:"",type:"address"}],payable:false,stateMutability:"view",type:"function"}],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[{"constant":true,"inputs":[{"name":"assetProxyId","type":"bytes4"}],"name":"getAssetProxy","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"assetProxyId","type":"bytes4"},{"name":"newAssetProxy","type":"address"},{"name":"oldAssetProxy","type":"address"}],"name":"registerAssetProxy","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"}],"devdoc":{"methods":{"getAssetProxy(bytes4)":{"details":"Gets an asset proxy.","params":{"assetProxyId":"Id of the asset proxy."},"return":"The asset proxy registered to assetProxyId. Returns 0x0 if no proxy is registered."},"registerAssetProxy(bytes4,address,address)":{"details":"Registers an asset proxy to an asset proxy id.      An id can only be assigned to a single proxy at a given time.","params":{"assetProxyId":"Id to register`newAssetProxy` under.","newAssetProxy":"Address of new asset proxy to register, or 0x0 to unset assetProxyId.","oldAssetProxy":"Existing asset proxy to overwrite, or 0x0 if assetProxyId is currently unused."}}}},"userdoc":{"methods":{}}},"settings":{"compilationTarget":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/Exchange/interfaces/IAssetProxyDispatcher.sol":"IAssetProxyDispatcher"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/Exchange/interfaces/IAssetProxyDispatcher.sol":{"keccak256":"0x283cfbe9da3a1416c9c4c699bff4e0039d7d7c80b538adf7674f18e1416aaef7","urls":["bzzr://b27c7df9ab900f8f4ffb5c652761f170b8830c31b5085b0e9ff19d50c1decf26"]}},"version":1}',bytecode:"0x",deployedBytecode:"0x",sourceMap:"",deployedSourceMap:"",source:'/*\n\n  Copyright 2018 ZeroEx Intl.\n\n  Licensed under the Apache License, Version 2.0 (the "License");\n  you may not use this file except in compliance with the License.\n  You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n  Unless required by applicable law or agreed to in writing, software\n  distributed under the License is distributed on an "AS IS" BASIS,\n  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  See the License for the specific language governing permissions and\n  limitations under the License.\n\n*/\n\npragma solidity 0.5.7;\n\ncontract IAssetProxyDispatcher {\n\n    /// @dev Registers an asset proxy to an asset proxy id.\n    ///      An id can only be assigned to a single proxy at a given time.\n    /// @param assetProxyId Id to register`newAssetProxy` under.\n    /// @param newAssetProxy Address of new asset proxy to register, or 0x0 to unset assetProxyId.\n    /// @param oldAssetProxy Existing asset proxy to overwrite, or 0x0 if assetProxyId is currently unused.\n    function registerAssetProxy(\n        bytes4 assetProxyId,\n        address newAssetProxy,\n        address oldAssetProxy\n    )\n        external;\n\n    /// @dev Gets an asset proxy.\n    /// @param assetProxyId Id of the asset proxy.\n    /// @return The asset proxy registered to assetProxyId. Returns 0x0 if no proxy is registered.\n    function getAssetProxy(bytes4 assetProxyId)\n        external\n        view\n        returns (address);\n}\n',sourcePath:"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/Exchange/interfaces/IAssetProxyDispatcher.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.449Z",devdoc:{methods:{"getAssetProxy(bytes4)":{details:"Gets an asset proxy.",params:{assetProxyId:"Id of the asset proxy."},"return":"The asset proxy registered to assetProxyId. Returns 0x0 if no proxy is registered."},"registerAssetProxy(bytes4,address,address)":{details:"Registers an asset proxy to an asset proxy id.      An id can only be assigned to a single proxy at a given time.",params:{assetProxyId:"Id to register`newAssetProxy` under.",newAssetProxy:"Address of new asset proxy to register, or 0x0 to unset assetProxyId.",oldAssetProxy:"Existing asset proxy to overwrite, or 0x0 if assetProxyId is currently unused."}}}},userdoc:{methods:{}}};