"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.IAuctionPriceCurve={contractName:"IAuctionPriceCurve",abi:[{constant:true,inputs:[],name:"priceDivisor",outputs:[{name:"",type:"uint256"}],payable:false,stateMutability:"view",type:"function"},{constant:true,inputs:[{components:[{name:"auctionStartTime",type:"uint256"},{name:"auctionTimeToPivot",type:"uint256"},{name:"auctionStartPrice",type:"uint256"},{name:"auctionPivotPrice",type:"uint256"}],name:"_auctionPriceParameters",type:"tuple"}],name:"validateAuctionPriceParameters",outputs:[],payable:false,stateMutability:"view",type:"function"},{constant:true,inputs:[{components:[{name:"auctionStartTime",type:"uint256"},{name:"auctionTimeToPivot",type:"uint256"},{name:"auctionStartPrice",type:"uint256"},{name:"auctionPivotPrice",type:"uint256"}],name:"_auctionPriceParameters",type:"tuple"}],name:"getCurrentPrice",outputs:[{name:"",type:"uint256"},{name:"",type:"uint256"}],payable:false,stateMutability:"view",type:"function"}],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[{"constant":true,"inputs":[{"components":[{"name":"auctionStartTime","type":"uint256"},{"name":"auctionTimeToPivot","type":"uint256"},{"name":"auctionStartPrice","type":"uint256"},{"name":"auctionPivotPrice","type":"uint256"}],"name":"_auctionPriceParameters","type":"tuple"}],"name":"validateAuctionPriceParameters","outputs":[],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"priceDivisor","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"components":[{"name":"auctionStartTime","type":"uint256"},{"name":"auctionTimeToPivot","type":"uint256"},{"name":"auctionStartPrice","type":"uint256"},{"name":"auctionPivotPrice","type":"uint256"}],"name":"_auctionPriceParameters","type":"tuple"}],"name":"getCurrentPrice","outputs":[{"name":"","type":"uint256"},{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"}],"devdoc":{"author":"Set Protocol * The IAuctionPriceCurve interface provides a structured way to interact with any AuctionLibrary","methods":{},"title":"IAuctionPriceCurve"},"userdoc":{"methods":{}}},"settings":{"compilationTarget":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/lib/auction-price-libraries/IAuctionPriceCurve.sol":"IAuctionPriceCurve"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/lib/RebalancingLibrary.sol":{"keccak256":"0x7f9dd2f95b2ee71a98b94cb9b0df15874aa134e7480d04a1fcf36aff166a55f4","urls":["bzzr://f43a5563ec5df095151eee30cf7a0941b5a971917c27c7b34d9586b36563ab5b"]},"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/lib/auction-price-libraries/IAuctionPriceCurve.sol":{"keccak256":"0x52e8b84f3475cb162f93666d1d32dd19cc8838a72c6934ebc22075e58a7acf1b","urls":["bzzr://5d6b372b7dcfab18dfa74013bedaadb1bb455d263dd414a30d01b05abbf5300c"]}},"version":1}',bytecode:"0x",deployedBytecode:"0x",sourceMap:"",deployedSourceMap:"",source:'/*\n    Copyright 2018 Set Labs Inc.\n\n    Licensed under the Apache License, Version 2.0 (the "License");\n    you may not use this file except in compliance with the License.\n    You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n    Unless required by applicable law or agreed to in writing, software\n    distributed under the License is distributed on an "AS IS" BASIS,\n    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n    See the License for the specific language governing permissions and\n    limitations under the License.\n*/\n\npragma solidity 0.5.7;\npragma experimental "ABIEncoderV2";\n\nimport { RebalancingLibrary } from "../RebalancingLibrary.sol";\n\n\n/**\n * @title IAuctionPriceCurve\n * @author Set Protocol\n *\n * The IAuctionPriceCurve interface provides a structured way to interact with any AuctionLibrary\n */\ninterface IAuctionPriceCurve {\n\n    /*\n     * Getter for priceDivisor variable on Auction Price Curve Library\n     */\n    function priceDivisor()\n        external\n        view\n        returns (uint256);\n\n    /*\n     * Validate any auction parameters that have library-specific restrictions\n     *\n     * @param _auctionPriceParameters   Struct containing relevant auction price parameters\n     */\n    function validateAuctionPriceParameters(\n        RebalancingLibrary.AuctionPriceParameters calldata _auctionPriceParameters\n    )\n        external\n        view;\n\n    /*\n     * Calculate the current priceRatio for an auction given defined price and time parameters\n     *\n     * @param _auctionPriceParameters     Struct containing relevant auction price parameters\n     * @return uint256                    The auction price numerator\n     * @return uint256                    The auction price denominator\n     */\n    function getCurrentPrice(\n        RebalancingLibrary.AuctionPriceParameters calldata _auctionPriceParameters\n    )\n        external\n        view\n        returns (uint256, uint256);\n}\n',sourcePath:"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/lib/auction-price-libraries/IAuctionPriceCurve.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.252Z",devdoc:{author:"Set Protocol * The IAuctionPriceCurve interface provides a structured way to interact with any AuctionLibrary",methods:{},title:"IAuctionPriceCurve"},userdoc:{methods:{}}};