"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.IOracle={contractName:"IOracle",abi:[{constant:true,inputs:[],name:"read",outputs:[{name:"",type:"uint256"}],payable:false,stateMutability:"view",type:"function"}],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[{"constant":true,"inputs":[],"name":"read","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"}],"devdoc":{"author":"Set Protocol * Interface for operating with any external Oracle that returns uint256 or an adapting contract that converts oracle output to uint256","methods":{"read()":{"return":"Current price of asset represented in uint256"}},"title":"IOracle"},"userdoc":{"methods":{"read()":{"notice":"Returns the queried data from an oracle returning uint256"}}}},"settings":{"compilationTarget":{"set-protocol-oracles/contracts/meta-oracles/interfaces/IOracle.sol":"IOracle"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"set-protocol-oracles/contracts/meta-oracles/interfaces/IOracle.sol":{"keccak256":"0xeb5a447a0b1ef47547ce12a91b72412880edb9690aa9bcd8746fc3a379f2fbe9","urls":["bzzr://261675b916b84f58bea71ec28c4f711291053174ddf47e860c26daaee506744a"]}},"version":1}',bytecode:"0x",deployedBytecode:"0x",sourceMap:"",deployedSourceMap:"",source:'/*\n    Copyright 2019 Set Labs Inc.\n\n    Licensed under the Apache License, Version 2.0 (the "License");\n    you may not use this file except in compliance with the License.\n    You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n    Unless required by applicable law or agreed to in writing, software\n    distributed under the License is distributed on an "AS IS" BASIS,\n    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n    See the License for the specific language governing permissions and\n    limitations under the License.\n*/\n\npragma solidity 0.5.7;\n\n\n/**\n * @title IOracle\n * @author Set Protocol\n *\n * Interface for operating with any external Oracle that returns uint256 or\n * an adapting contract that converts oracle output to uint256\n */\ninterface IOracle {\n\n    /**\n     * Returns the queried data from an oracle returning uint256\n     *\n     * @return  Current price of asset represented in uint256\n     */\n    function read()\n        external\n        view\n        returns (uint256);\n}',sourcePath:"set-protocol-oracles/contracts/meta-oracles/interfaces/IOracle.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.569Z",devdoc:{author:"Set Protocol * Interface for operating with any external Oracle that returns uint256 or an adapting contract that converts oracle output to uint256",methods:{"read()":{"return":"Current price of asset represented in uint256"}},title:"IOracle"},userdoc:{methods:{"read()":{notice:"Returns the queried data from an oracle returning uint256"}}}};