"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.IOracleWhiteList={contractName:"IOracleWhiteList",abi:[{constant:true,inputs:[{name:"_tokenAddress",type:"address"}],name:"oracleWhiteList",outputs:[{name:"",type:"address"}],payable:false,stateMutability:"view",type:"function"},{constant:true,inputs:[{name:"_addresses",type:"address[]"}],name:"areValidAddresses",outputs:[{name:"",type:"bool"}],payable:false,stateMutability:"view",type:"function"},{constant:true,inputs:[{name:"_tokenAddresses",type:"address[]"}],name:"getOracleAddressesByToken",outputs:[{name:"",type:"address[]"}],payable:false,stateMutability:"view",type:"function"},{constant:true,inputs:[{name:"_token",type:"address"}],name:"getOracleAddressByToken",outputs:[{name:"",type:"address"}],payable:false,stateMutability:"view",type:"function"}],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[{"constant":true,"inputs":[{"name":"_addresses","type":"address[]"}],"name":"areValidAddresses","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"_token","type":"address"}],"name":"getOracleAddressByToken","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"_tokenAddress","type":"address"}],"name":"oracleWhiteList","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"_tokenAddresses","type":"address[]"}],"name":"getOracleAddressesByToken","outputs":[{"name":"","type":"address[]"}],"payable":false,"stateMutability":"view","type":"function"}],"devdoc":{"author":"Set Protocol * The IWhiteList interface exposes the whitelist mapping to check components","methods":{"areValidAddresses(address[])":{"params":{"_addresses":"Array of addresses to verify"},"return":"bool          Whether all addresses in the list are whitelsited"},"getOracleAddressesByToken(address[])":{"params":{"_tokenAddresses":"Array of token addresses to get oracle addresses for"},"return":"address[]          Array of oracle addresses"},"oracleWhiteList(address)":{"params":{"_tokenAddress":"Address to check"},"return":"bool                Whether passed in address is whitelisted"}},"title":"IOracleWhiteList"},"userdoc":{"methods":{"areValidAddresses(address[])":{"notice":"Verifies an array of token addresses against the whitelist"},"getOracleAddressesByToken(address[])":{"notice":"Return array of oracle addresses based on passed in token addresses "},"oracleWhiteList(address)":{"notice":"Returns oracle of passed token address (not in array form)"}}}},"settings":{"compilationTarget":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/IOracleWhiteList.sol":"IOracleWhiteList"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/IOracleWhiteList.sol":{"keccak256":"0xc4623b7082c6e017d1f820a05289a71d4262c01444ff1571e92f64a4e82662af","urls":["bzzr://c11cc5b2b50c5e708a09b10adf350e9ea3d3427cc2f199516db4ae9be498aaac"]}},"version":1}',bytecode:"0x",deployedBytecode:"0x",sourceMap:"",deployedSourceMap:"",source:'/*\n    Copyright 2019 Set Labs Inc.\n\n    Licensed under the Apache License, Version 2.0 (the "License");\n    you may not use this file except in compliance with the License.\n    You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n    Unless required by applicable law or agreed to in writing, software\n    distributed under the License is distributed on an "AS IS" BASIS,\n    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n    See the License for the specific language governing permissions and\n    limitations under the License.\n*/\n\npragma solidity 0.5.7;\n\n/**\n * @title IOracleWhiteList\n * @author Set Protocol\n *\n * The IWhiteList interface exposes the whitelist mapping to check components\n */\ninterface IOracleWhiteList {\n\n    /* ============ External Functions ============ */\n\n    /**\n     * Returns oracle of passed token address (not in array form)\n     *\n     * @param  _tokenAddress       Address to check\n     * @return bool                Whether passed in address is whitelisted\n     */\n    function oracleWhiteList(\n        address _tokenAddress\n    )\n        external\n        view\n        returns (address);\n\n    /**\n     * Verifies an array of token addresses against the whitelist\n     *\n     * @param  _addresses    Array of addresses to verify\n     * @return bool          Whether all addresses in the list are whitelsited\n     */\n    function areValidAddresses(\n        address[] calldata _addresses\n    )\n        external\n        view\n        returns (bool);\n\n    /**\n     * Return array of oracle addresses based on passed in token addresses \n     *\n     * @param  _tokenAddresses    Array of token addresses to get oracle addresses for\n     * @return address[]          Array of oracle addresses\n     */\n    function getOracleAddressesByToken(\n        address[] calldata _tokenAddresses\n    )\n        external\n        view\n        returns (address[] memory);\n\n    function getOracleAddressByToken(\n        address _token\n    )\n        external\n        view\n        returns (address);\n}\n',sourcePath:"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/IOracleWhiteList.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.202Z",devdoc:{author:"Set Protocol * The IWhiteList interface exposes the whitelist mapping to check components",methods:{"areValidAddresses(address[])":{params:{_addresses:"Array of addresses to verify"},"return":"bool          Whether all addresses in the list are whitelsited"},"getOracleAddressesByToken(address[])":{params:{_tokenAddresses:"Array of token addresses to get oracle addresses for"},"return":"address[]          Array of oracle addresses"},"oracleWhiteList(address)":{params:{_tokenAddress:"Address to check"},"return":"bool                Whether passed in address is whitelisted"}},title:"IOracleWhiteList"},userdoc:{methods:{"areValidAddresses(address[])":{notice:"Verifies an array of token addresses against the whitelist"},"getOracleAddressesByToken(address[])":{notice:"Return array of oracle addresses based on passed in token addresses "},"oracleWhiteList(address)":{notice:"Returns oracle of passed token address (not in array form)"}}}};