"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.IRebalanceAuctionModule={contractName:"IRebalanceAuctionModule",abi:[{constant:false,inputs:[{name:"_rebalancingSetToken",type:"address"},{name:"_quantity",type:"uint256"},{name:"_allowPartialFill",type:"bool"}],name:"bidAndWithdraw",outputs:[],payable:false,stateMutability:"nonpayable",type:"function"}],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[{"constant":false,"inputs":[{"name":"_rebalancingSetToken","type":"address"},{"name":"_quantity","type":"uint256"},{"name":"_allowPartialFill","type":"bool"}],"name":"bidAndWithdraw","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"}],"devdoc":{"author":"Set Protocol * The IRebalanceAuctionModule interface provides a light-weight, structured way to interact with the RebalanceAuctionModule contract from another contract.","methods":{"bidAndWithdraw(address,uint256,bool)":{"params":{"_allowPartialFill":"Set to true if want to partially fill bid when quantity                                is greater than currentRemainingSets","_quantity":"Number of currentSets to rebalance","_rebalancingSetToken":"Address of the rebalancing token being bid on"}}},"title":"IRebalanceAuctionModule"},"userdoc":{"methods":{"bidAndWithdraw(address,uint256,bool)":{"notice":"Bid on rebalancing a given quantity of sets held by a rebalancing token The tokens are returned to the user."}}}},"settings":{"compilationTarget":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/IRebalanceAuctionModule.sol":"IRebalanceAuctionModule"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/IRebalanceAuctionModule.sol":{"keccak256":"0x83643b2fb1bf0c842a847cc76e84ac3db3f66e93065ae3a8edad93ab627ba104","urls":["bzzr://0342c1eb46311b8f388df55eacfd370cea99e6dc0f31756b19daecb9700a1d68"]}},"version":1}',bytecode:"0x",deployedBytecode:"0x",sourceMap:"",deployedSourceMap:"",source:'/*\n    Copyright 2019 Set Labs Inc.\n\n    Licensed under the Apache License, Version 2.0 (the "License");\n    you may not use this file except in compliance with the License.\n    You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n    Unless required by applicable law or agreed to in writing, software\n    distributed under the License is distributed on an "AS IS" BASIS,\n    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n    See the License for the specific language governing permissions and\n    limitations under the License.\n*/\n\npragma solidity 0.5.7;\npragma experimental "ABIEncoderV2";\n\n/**\n * @title IRebalanceAuctionModule\n * @author Set Protocol\n *\n * The IRebalanceAuctionModule interface provides a light-weight, structured way to interact with the\n * RebalanceAuctionModule contract from another contract.\n */\n\ninterface IRebalanceAuctionModule {\n    /**\n     * Bid on rebalancing a given quantity of sets held by a rebalancing token\n     * The tokens are returned to the user.\n     *\n     * @param  _rebalancingSetToken    Address of the rebalancing token being bid on\n     * @param  _quantity               Number of currentSets to rebalance\n     * @param  _allowPartialFill       Set to true if want to partially fill bid when quantity\n     *                                 is greater than currentRemainingSets\n     */\n    function bidAndWithdraw(\n        address _rebalancingSetToken,\n        uint256 _quantity,\n        bool _allowPartialFill\n    )\n        external;\n}\n',sourcePath:"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/IRebalanceAuctionModule.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.205Z",devdoc:{author:"Set Protocol * The IRebalanceAuctionModule interface provides a light-weight, structured way to interact with the RebalanceAuctionModule contract from another contract.",methods:{"bidAndWithdraw(address,uint256,bool)":{params:{_allowPartialFill:"Set to true if want to partially fill bid when quantity                                is greater than currentRemainingSets",_quantity:"Number of currentSets to rebalance",_rebalancingSetToken:"Address of the rebalancing token being bid on"}}},title:"IRebalanceAuctionModule"},userdoc:{methods:{"bidAndWithdraw(address,uint256,bool)":{notice:"Bid on rebalancing a given quantity of sets held by a rebalancing token The tokens are returned to the user."}}}};