"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ISetFactory={contractName:"ISetFactory",abi:[{constant:false,inputs:[],name:"core",outputs:[{name:"",type:"address"}],payable:false,stateMutability:"nonpayable",type:"function"},{constant:false,inputs:[{name:"_components",type:"address[]"},{name:"_units",type:"uint256[]"},{name:"_naturalUnit",type:"uint256"},{name:"_name",type:"bytes32"},{name:"_symbol",type:"bytes32"},{name:"_callData",type:"bytes"}],name:"createSet",outputs:[{name:"",type:"address"}],payable:false,stateMutability:"nonpayable",type:"function"}],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[{"constant":false,"inputs":[{"name":"_components","type":"address[]"},{"name":"_units","type":"uint256[]"},{"name":"_naturalUnit","type":"uint256"},{"name":"_name","type":"bytes32"},{"name":"_symbol","type":"bytes32"},{"name":"_callData","type":"bytes"}],"name":"createSet","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[],"name":"core","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"nonpayable","type":"function"}],"devdoc":{"author":"Set Protocol * The ISetFactory interface provides operability for authorized contracts to interact with SetTokenFactory","methods":{"core()":{"return":"address        core address"},"createSet(address[],uint256[],uint256,bytes32,bytes32,bytes)":{"params":{"_callData":"Byte string containing additional call parameters","_components":"The address of component tokens","_name":"The bytes32 encoded name of the new Set","_naturalUnit":"The minimum unit to be issued or redeemed","_symbol":"The bytes32 encoded symbol of the new Set","_units":"The units of each component token"},"return":"setTokenAddress       The address of the new Set"}},"title":"ISetFactory"},"userdoc":{"methods":{"core()":{"notice":"Return core address"},"createSet(address[],uint256[],uint256,bytes32,bytes32,bytes)":{"notice":"Deploys a new Set Token and adds it to the valid list of SetTokens"}}}},"settings":{"compilationTarget":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/ISetFactory.sol":"ISetFactory"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/ISetFactory.sol":{"keccak256":"0xf795ab9e9ac11340a600f235073b4ec4bdea92d3c01601ced1e5afd3c2718301","urls":["bzzr://eb4f00f66933560aa133ee90030b23d7a30937e6591a83d56b3935a927e8ca9f"]}},"version":1}',bytecode:"0x",deployedBytecode:"0x",sourceMap:"",deployedSourceMap:"",source:'/*\n    Copyright 2018 Set Labs Inc.\n\n    Licensed under the Apache License, Version 2.0 (the "License");\n    you may not use this file except in compliance with the License.\n    You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n    Unless required by applicable law or agreed to in writing, software\n    distributed under the License is distributed on an "AS IS" BASIS,\n    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n    See the License for the specific language governing permissions and\n    limitations under the License.\n*/\n\npragma solidity 0.5.7;\n\n\n/**\n * @title ISetFactory\n * @author Set Protocol\n *\n * The ISetFactory interface provides operability for authorized contracts\n * to interact with SetTokenFactory\n */\ninterface ISetFactory {\n\n    /* ============ External Functions ============ */\n\n    /**\n     * Return core address\n     *\n     * @return address        core address\n     */\n    function core()\n        external\n        returns (address);\n\n    /**\n     * Deploys a new Set Token and adds it to the valid list of SetTokens\n     *\n     * @param  _components           The address of component tokens\n     * @param  _units                The units of each component token\n     * @param  _naturalUnit          The minimum unit to be issued or redeemed\n     * @param  _name                 The bytes32 encoded name of the new Set\n     * @param  _symbol               The bytes32 encoded symbol of the new Set\n     * @param  _callData             Byte string containing additional call parameters\n     * @return setTokenAddress       The address of the new Set\n     */\n    function createSet(\n        address[] calldata _components,\n        uint[] calldata _units,\n        uint256 _naturalUnit,\n        bytes32 _name,\n        bytes32 _symbol,\n        bytes calldata _callData\n    )\n        external\n        returns (address);\n}\n',sourcePath:"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/ISetFactory.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.216Z",devdoc:{author:"Set Protocol * The ISetFactory interface provides operability for authorized contracts to interact with SetTokenFactory",methods:{"core()":{"return":"address        core address"},"createSet(address[],uint256[],uint256,bytes32,bytes32,bytes)":{params:{_callData:"Byte string containing additional call parameters",_components:"The address of component tokens",_name:"The bytes32 encoded name of the new Set",_naturalUnit:"The minimum unit to be issued or redeemed",_symbol:"The bytes32 encoded symbol of the new Set",_units:"The units of each component token"},"return":"setTokenAddress       The address of the new Set"}},title:"ISetFactory"},userdoc:{methods:{"core()":{notice:"Return core address"},"createSet(address[],uint256[],uint256,bytes32,bytes32,bytes)":{notice:"Deploys a new Set Token and adds it to the valid list of SetTokens"}}}};