"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ISignatureValidator={contractName:"ISignatureValidator",abi:[{constant:false,inputs:[{name:"hash",type:"bytes32"},{name:"signerAddress",type:"address"},{name:"signature",type:"bytes"}],name:"preSign",outputs:[],payable:false,stateMutability:"nonpayable",type:"function"},{constant:false,inputs:[{name:"validatorAddress",type:"address"},{name:"approval",type:"bool"}],name:"setSignatureValidatorApproval",outputs:[],payable:false,stateMutability:"nonpayable",type:"function"},{constant:true,inputs:[{name:"hash",type:"bytes32"},{name:"signerAddress",type:"address"},{name:"signature",type:"bytes"}],name:"isValidSignature",outputs:[{name:"isValid",type:"bool"}],payable:false,stateMutability:"view",type:"function"}],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[{"constant":false,"inputs":[{"name":"hash","type":"bytes32"},{"name":"signerAddress","type":"address"},{"name":"signature","type":"bytes"}],"name":"preSign","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"validatorAddress","type":"address"},{"name":"approval","type":"bool"}],"name":"setSignatureValidatorApproval","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"name":"hash","type":"bytes32"},{"name":"signerAddress","type":"address"},{"name":"signature","type":"bytes"}],"name":"isValidSignature","outputs":[{"name":"isValid","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"}],"devdoc":{"methods":{"isValidSignature(bytes32,address,bytes)":{"details":"Verifies that a signature is valid.","params":{"hash":"Message hash that is signed.","signature":"Proof of signing.","signerAddress":"Address of signer."},"return":"Validity of order signature."},"preSign(bytes32,address,bytes)":{"details":"Approves a hash on-chain using any valid signature type.      After presigning a hash, the preSign signature type will become valid for that hash and signer.","params":{"signature":"Proof that the hash has been signed by signer.","signerAddress":"Address that should have signed the given hash."}},"setSignatureValidatorApproval(address,bool)":{"details":"Approves/unnapproves a Validator contract to verify signatures on signer\'s behalf.","params":{"approval":"Approval or disapproval of  Validator contract.","validatorAddress":"Address of Validator contract."}}}},"userdoc":{"methods":{}}},"settings":{"compilationTarget":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/Exchange/interfaces/ISignatureValidator.sol":"ISignatureValidator"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/Exchange/interfaces/ISignatureValidator.sol":{"keccak256":"0x3bf5228d3ef009bc84e68cb302ae330efac12d4f1fbe08c385dee519dc9ee3ed","urls":["bzzr://f52f8acf747e68a61c834c2023f6cb76c6d9feb9b84a4693de22be00fddc21f1"]}},"version":1}',bytecode:"0x",deployedBytecode:"0x",sourceMap:"",deployedSourceMap:"",source:'/*\n\n  Copyright 2018 ZeroEx Intl.\n\n  Licensed under the Apache License, Version 2.0 (the "License");\n  you may not use this file except in compliance with the License.\n  You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n  Unless required by applicable law or agreed to in writing, software\n  distributed under the License is distributed on an "AS IS" BASIS,\n  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  See the License for the specific language governing permissions and\n  limitations under the License.\n\n*/\n\npragma solidity 0.5.7;\n\ncontract ISignatureValidator {\n\n    /// @dev Approves a hash on-chain using any valid signature type.\n    ///      After presigning a hash, the preSign signature type will become valid for that hash and signer.\n    /// @param signerAddress Address that should have signed the given hash.\n    /// @param signature Proof that the hash has been signed by signer.\n    function preSign(\n        bytes32 hash,\n        address signerAddress,\n        bytes calldata signature\n    )\n        external;\n\n    /// @dev Approves/unnapproves a Validator contract to verify signatures on signer\'s behalf.\n    /// @param validatorAddress Address of Validator contract.\n    /// @param approval Approval or disapproval of  Validator contract.\n    function setSignatureValidatorApproval(\n        address validatorAddress,\n        bool approval\n    )\n        external;\n\n    /// @dev Verifies that a signature is valid.\n    /// @param hash Message hash that is signed.\n    /// @param signerAddress Address of signer.\n    /// @param signature Proof of signing.\n    /// @return Validity of order signature.\n    function isValidSignature(\n        bytes32 hash,\n        address signerAddress,\n        bytes memory signature\n    )\n        public\n        view\n        returns (bool isValid);\n}\n',sourcePath:"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/Exchange/interfaces/ISignatureValidator.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.452Z",devdoc:{methods:{"isValidSignature(bytes32,address,bytes)":{details:"Verifies that a signature is valid.",params:{hash:"Message hash that is signed.",signature:"Proof of signing.",signerAddress:"Address of signer."},"return":"Validity of order signature."},"preSign(bytes32,address,bytes)":{details:"Approves a hash on-chain using any valid signature type.      After presigning a hash, the preSign signature type will become valid for that hash and signer.",params:{signature:"Proof that the hash has been signed by signer.",signerAddress:"Address that should have signed the given hash."}},"setSignatureValidatorApproval(address,bool)":{details:"Approves/unnapproves a Validator contract to verify signatures on signer's behalf.",params:{approval:"Approval or disapproval of  Validator contract.",validatorAddress:"Address of Validator contract."}}}},userdoc:{methods:{}}};