"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ITransactions={contractName:"ITransactions",abi:[{constant:false,inputs:[{name:"salt",type:"uint256"},{name:"signerAddress",type:"address"},{name:"data",type:"bytes"},{name:"signature",type:"bytes"}],name:"executeTransaction",outputs:[],payable:false,stateMutability:"nonpayable",type:"function"}],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[{"constant":false,"inputs":[{"name":"salt","type":"uint256"},{"name":"signerAddress","type":"address"},{"name":"data","type":"bytes"},{"name":"signature","type":"bytes"}],"name":"executeTransaction","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"}],"devdoc":{"methods":{"executeTransaction(uint256,address,bytes,bytes)":{"details":"Executes an exchange method call in the context of signer.","params":{"data":"AbiV2 encoded calldata.","salt":"Arbitrary number to ensure uniqueness of transaction hash.","signature":"Proof of signer transaction by signer.","signerAddress":"Address of transaction signer."}}}},"userdoc":{"methods":{}}},"settings":{"compilationTarget":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/Exchange/interfaces/ITransactions.sol":"ITransactions"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/Exchange/interfaces/ITransactions.sol":{"keccak256":"0x3023098ad34e97e1ab3afba65ed6e9687f4edf0af00fb62d6cabbec98f55e524","urls":["bzzr://2c07e913d2e6eb25f8ba14243d68c14d47cf8dbe95ca54932c54e2388c79dcce"]}},"version":1}',bytecode:"0x",deployedBytecode:"0x",sourceMap:"",deployedSourceMap:"",source:'/*\n\n  Copyright 2018 ZeroEx Intl.\n\n  Licensed under the Apache License, Version 2.0 (the "License");\n  you may not use this file except in compliance with the License.\n  You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n  Unless required by applicable law or agreed to in writing, software\n  distributed under the License is distributed on an "AS IS" BASIS,\n  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  See the License for the specific language governing permissions and\n  limitations under the License.\n\n*/\npragma solidity 0.5.7;\n\ncontract ITransactions {\n\n    /// @dev Executes an exchange method call in the context of signer.\n    /// @param salt Arbitrary number to ensure uniqueness of transaction hash.\n    /// @param signerAddress Address of transaction signer.\n    /// @param data AbiV2 encoded calldata.\n    /// @param signature Proof of signer transaction by signer.\n    function executeTransaction(\n        uint256 salt,\n        address signerAddress,\n        bytes calldata data,\n        bytes calldata signature\n    )\n        external;\n}\n',sourcePath:"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/Exchange/interfaces/ITransactions.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.453Z",devdoc:{methods:{"executeTransaction(uint256,address,bytes,bytes)":{details:"Executes an exchange method call in the context of signer.",params:{data:"AbiV2 encoded calldata.",salt:"Arbitrary number to ensure uniqueness of transaction hash.",signature:"Proof of signer transaction by signer.",signerAddress:"Address of transaction signer."}}}},userdoc:{methods:{}}};