"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ITransferProxy={contractName:"ITransferProxy",abi:[{constant:false,inputs:[{name:"_token",type:"address"},{name:"_quantity",type:"uint256"},{name:"_from",type:"address"},{name:"_to",type:"address"}],name:"transfer",outputs:[],payable:false,stateMutability:"nonpayable",type:"function"},{constant:false,inputs:[{name:"_tokens",type:"address[]"},{name:"_quantities",type:"uint256[]"},{name:"_from",type:"address"},{name:"_to",type:"address"}],name:"batchTransfer",outputs:[],payable:false,stateMutability:"nonpayable",type:"function"}],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[{"constant":false,"inputs":[{"name":"_tokens","type":"address[]"},{"name":"_quantities","type":"uint256[]"},{"name":"_from","type":"address"},{"name":"_to","type":"address"}],"name":"batchTransfer","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"_token","type":"address"},{"name":"_quantity","type":"uint256"},{"name":"_from","type":"address"},{"name":"_to","type":"address"}],"name":"transfer","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"}],"devdoc":{"author":"Set Protocol * The ITransferProxy interface provides a light-weight, structured way to interact with the TransferProxy contract from another contract.","methods":{"batchTransfer(address[],uint256[],address,address)":{"params":{"_from":"The address to transfer from","_quantities":"The numbers of tokens to transfer","_to":"The address to transfer to","_tokens":"The addresses of the ERC20 token"}},"transfer(address,uint256,address,address)":{"params":{"_from":"The address to transfer from","_quantity":"The number of tokens to transfer","_to":"The address to transfer to","_token":"The address of the ERC20 token"}}},"title":"ITransferProxy"},"userdoc":{"methods":{"batchTransfer(address[],uint256[],address,address)":{"notice":"Transfers tokens from an address (that has set allowance on the proxy). Can only be called by authorized core contracts."},"transfer(address,uint256,address,address)":{"notice":"Transfers tokens from an address (that has set allowance on the proxy). Can only be called by authorized core contracts."}}}},"settings":{"compilationTarget":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/ITransferProxy.sol":"ITransferProxy"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/ITransferProxy.sol":{"keccak256":"0x962d54385cc4760c550cd2f16bfdb53e967def4c5d3acb7b3d0b3d7a49f902de","urls":["bzzr://cb8994c8bae7fa1d55d240f44396f4156b45c81afa6fcfa608fd5e4bf9f1a919"]}},"version":1}',bytecode:"0x",deployedBytecode:"0x",sourceMap:"",deployedSourceMap:"",source:'/*\n    Copyright 2018 Set Labs Inc.\n\n    Licensed under the Apache License, Version 2.0 (the "License");\n    you may not use this file except in compliance with the License.\n    You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n    Unless required by applicable law or agreed to in writing, software\n    distributed under the License is distributed on an "AS IS" BASIS,\n    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n    See the License for the specific language governing permissions and\n    limitations under the License.\n*/\n\npragma solidity 0.5.7;\n\n/**\n * @title ITransferProxy\n * @author Set Protocol\n *\n * The ITransferProxy interface provides a light-weight, structured way to interact with the\n * TransferProxy contract from another contract.\n */\ninterface ITransferProxy {\n\n    /* ============ External Functions ============ */\n\n    /**\n     * Transfers tokens from an address (that has set allowance on the proxy).\n     * Can only be called by authorized core contracts.\n     *\n     * @param  _token          The address of the ERC20 token\n     * @param  _quantity       The number of tokens to transfer\n     * @param  _from           The address to transfer from\n     * @param  _to             The address to transfer to\n     */\n    function transfer(\n        address _token,\n        uint256 _quantity,\n        address _from,\n        address _to\n    )\n        external;\n\n    /**\n     * Transfers tokens from an address (that has set allowance on the proxy).\n     * Can only be called by authorized core contracts.\n     *\n     * @param  _tokens         The addresses of the ERC20 token\n     * @param  _quantities     The numbers of tokens to transfer\n     * @param  _from           The address to transfer from\n     * @param  _to             The address to transfer to\n     */\n    function batchTransfer(\n        address[] calldata _tokens,\n        uint256[] calldata _quantities,\n        address _from,\n        address _to\n    )\n        external;\n}\n',sourcePath:"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/ITransferProxy.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.221Z",devdoc:{author:"Set Protocol * The ITransferProxy interface provides a light-weight, structured way to interact with the TransferProxy contract from another contract.",methods:{"batchTransfer(address[],uint256[],address,address)":{params:{_from:"The address to transfer from",_quantities:"The numbers of tokens to transfer",_to:"The address to transfer to",_tokens:"The addresses of the ERC20 token"}},"transfer(address,uint256,address,address)":{params:{_from:"The address to transfer from",_quantity:"The number of tokens to transfer",_to:"The address to transfer to",_token:"The address of the ERC20 token"}}},title:"ITransferProxy"},userdoc:{methods:{"batchTransfer(address[],uint256[],address,address)":{notice:"Transfers tokens from an address (that has set allowance on the proxy). Can only be called by authorized core contracts."},"transfer(address,uint256,address,address)":{notice:"Transfers tokens from an address (that has set allowance on the proxy). Can only be called by authorized core contracts."}}}};