"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.IWhiteList={contractName:"IWhiteList",abi:[{constant:true,inputs:[{name:"_address",type:"address"}],name:"whiteList",outputs:[{name:"",type:"bool"}],payable:false,stateMutability:"view",type:"function"},{constant:true,inputs:[{name:"_addresses",type:"address[]"}],name:"areValidAddresses",outputs:[{name:"",type:"bool"}],payable:false,stateMutability:"view",type:"function"}],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[{"constant":true,"inputs":[{"name":"_addresses","type":"address[]"}],"name":"areValidAddresses","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"_address","type":"address"}],"name":"whiteList","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"}],"devdoc":{"author":"Set Protocol * The IWhiteList interface exposes the whitelist mapping to check components","methods":{"areValidAddresses(address[])":{"params":{"_addresses":"Array of addresses to verify"},"return":"bool          Whether all addresses in the list are whitelsited"},"whiteList(address)":{"params":{"_address":"Address to check"},"return":"bool           Whether passed in address is whitelisted"}},"title":"IWhiteList"},"userdoc":{"methods":{"areValidAddresses(address[])":{"notice":"Verifies an array of addresses against the whitelist"},"whiteList(address)":{"notice":"Validates address against white list"}}}},"settings":{"compilationTarget":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/IWhiteList.sol":"IWhiteList"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/IWhiteList.sol":{"keccak256":"0x35158bdba86e9e08faf0bdf5e1756fb20ee0404e0b0b3c2d529e0e5b03b5adfd","urls":["bzzr://130cfe1fe490b464a6d42fd8613dd42a9f3375f24b6ab2dd91448f12895992ab"]}},"version":1}',bytecode:"0x",deployedBytecode:"0x",sourceMap:"",deployedSourceMap:"",source:'/*\n    Copyright 2018 Set Labs Inc.\n\n    Licensed under the Apache License, Version 2.0 (the "License");\n    you may not use this file except in compliance with the License.\n    You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n    Unless required by applicable law or agreed to in writing, software\n    distributed under the License is distributed on an "AS IS" BASIS,\n    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n    See the License for the specific language governing permissions and\n    limitations under the License.\n*/\n\npragma solidity 0.5.7;\n\n/**\n * @title IWhiteList\n * @author Set Protocol\n *\n * The IWhiteList interface exposes the whitelist mapping to check components\n */\ninterface IWhiteList {\n\n    /* ============ External Functions ============ */\n\n    /**\n     * Validates address against white list\n     *\n     * @param  _address       Address to check\n     * @return bool           Whether passed in address is whitelisted\n     */\n    function whiteList(\n        address _address\n    )\n        external\n        view\n        returns (bool);\n\n    /**\n     * Verifies an array of addresses against the whitelist\n     *\n     * @param  _addresses    Array of addresses to verify\n     * @return bool          Whether all addresses in the list are whitelsited\n     */\n    function areValidAddresses(\n        address[] calldata _addresses\n    )\n        external\n        view\n        returns (bool);\n}\n',sourcePath:"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/IWhiteList.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.225Z",devdoc:{author:"Set Protocol * The IWhiteList interface exposes the whitelist mapping to check components",methods:{"areValidAddresses(address[])":{params:{_addresses:"Array of addresses to verify"},"return":"bool          Whether all addresses in the list are whitelsited"},"whiteList(address)":{params:{_address:"Address to check"},"return":"bool           Whether passed in address is whitelisted"}},title:"IWhiteList"},userdoc:{methods:{"areValidAddresses(address[])":{notice:"Verifies an array of addresses against the whitelist"},"whiteList(address)":{notice:"Validates address against white list"}}}};