"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.LibExchangeErrors={contractName:"LibExchangeErrors",abi:[],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[],"devdoc":{"details":"This contract documents the revert reasons used in the Exchange contract. This contract is intended to serve as a reference, but is not actually used for efficiency reasons.","methods":{}},"userdoc":{"methods":{}}},"settings":{"compilationTarget":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/Exchange/libs/LibExchangeErrors.sol":"LibExchangeErrors"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/Exchange/libs/LibExchangeErrors.sol":{"keccak256":"0xcc6e49124afb5428e05dfc326638d535244b868ca44b718785d4bd1451594f86","urls":["bzzr://decea646a95c72d5cdab558c418a14e34d2d27ab5ab7d699a7cda82ee09c496c"]}},"version":1}',bytecode:"0x6080604052348015600f57600080fd5b50603580601d6000396000f3fe6080604052600080fdfea165627a7a723058202f07e0a525f50524ee7dbd5b6e84b51c28e6a254cb608036d037f68b9d82a3be0029",deployedBytecode:"0x6080604052600080fdfea165627a7a723058202f07e0a525f50524ee7dbd5b6e84b51c28e6a254cb608036d037f68b9d82a3be0029",sourceMap:"791:3623:110:-;;;;8:9:-1;5:2;;;30:1;27;20:12;5:2;791:3623:110;;;;;;;",deployedSourceMap:"791:3623:110:-;;;;;",source:'/*\n\n  Copyright 2018 ZeroEx Intl.\n\n  Licensed under the Apache License, Version 2.0 (the "License");\n  you may not use this file except in compliance with the License.\n  You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n  Unless required by applicable law or agreed to in writing, software\n  distributed under the License is distributed on an "AS IS" BASIS,\n  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  See the License for the specific language governing permissions and\n  limitations under the License.\n\n*/\n\npragma solidity 0.5.7;\n\n/// @dev This contract documents the revert reasons used in the Exchange contract.\n/// This contract is intended to serve as a reference, but is not actually used for efficiency reasons.\ncontract LibExchangeErrors {\n\n    /// Order validation errors ///\n    string constant ORDER_UNFILLABLE = "ORDER_UNFILLABLE";                              // Order cannot be filled.\n    string constant INVALID_MAKER = "INVALID_MAKER";                                    // Invalid makerAddress.\n    string constant INVALID_TAKER = "INVALID_TAKER";                                    // Invalid takerAddress.\n    string constant INVALID_SENDER = "INVALID_SENDER";                                  // Invalid `msg.sender`.\n    string constant INVALID_ORDER_SIGNATURE = "INVALID_ORDER_SIGNATURE";                // Signature validation failed.\n\n    /// fillOrder validation errors ///\n    string constant INVALID_TAKER_AMOUNT = "INVALID_TAKER_AMOUNT";                      // takerAssetFillAmount cannot equal 0.\n    string constant ROUNDING_ERROR = "ROUNDING_ERROR";                                  // Rounding error greater than 0.1% of takerAssetFillAmount.\n\n    /// Signature validation errors ///\n    string constant INVALID_SIGNATURE = "INVALID_SIGNATURE";                            // Signature validation failed.\n    string constant SIGNATURE_ILLEGAL = "SIGNATURE_ILLEGAL";                            // Signature type is illegal.\n    string constant SIGNATURE_UNSUPPORTED = "SIGNATURE_UNSUPPORTED";                    // Signature type unsupported.\n\n    /// cancelOrdersUptTo errors ///\n    string constant INVALID_NEW_ORDER_EPOCH = "INVALID_NEW_ORDER_EPOCH";                // Specified salt must be greater than or equal to existing orderEpoch.\n\n    /// fillOrKillOrder errors ///\n    string constant COMPLETE_FILL_FAILED = "COMPLETE_FILL_FAILED";                      // Desired takerAssetFillAmount could not be completely filled.\n\n    /// matchOrders errors ///\n    string constant NEGATIVE_SPREAD_REQUIRED = "NEGATIVE_SPREAD_REQUIRED";              // Matched orders must have a negative spread.\n\n    /// Transaction errors ///\n    string constant REENTRANCY_ILLEGAL = "REENTRANCY_ILLEGAL";                          // Recursive reentrancy is not allowed.\n    string constant INVALID_TX_HASH = "INVALID_TX_HASH";                                // Transaction has already been executed.\n    string constant INVALID_TX_SIGNATURE = "INVALID_TX_SIGNATURE";                      // Signature validation failed.\n    string constant FAILED_EXECUTION = "FAILED_EXECUTION";                              // Transaction execution failed.\n\n    /// registerAssetProxy errors ///\n    string constant ASSET_PROXY_MISMATCH = "ASSET_PROXY_MISMATCH";                      // oldAssetProxy proxy does not match currentAssetProxy.\n    string constant ASSET_PROXY_ID_MISMATCH = "ASSET_PROXY_ID_MISMATCH";                // newAssetProxyId does not match given assetProxyId.\n\n    /// dispatchTransferFrom errors ///\n    string constant ASSET_PROXY_DOES_NOT_EXIST = "ASSET_PROXY_DOES_NOT_EXIST";          // No assetProxy registered at given id.\n    string constant TRANSFER_FAILED = "TRANSFER_FAILED";                                // Asset transfer unsuccesful.\n\n    /// Length validation errors ///\n    string constant LENGTH_GREATER_THAN_0_REQUIRED = "LENGTH_GREATER_THAN_0_REQUIRED";  // Byte array must have a length greater than 0.\n    string constant LENGTH_GREATER_THAN_3_REQUIRED = "LENGTH_GREATER_THAN_3_REQUIRED";  // Byte array must have a length greater than 3.\n    string constant LENGTH_0_REQUIRED = "LENGTH_0_REQUIRED";                            // Byte array must have a length of 0.\n    string constant LENGTH_65_REQUIRED = "LENGTH_65_REQUIRED";                          // Byte array must have a length of 65.\n}\n',sourcePath:"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/external/0x/Exchange/libs/LibExchangeErrors.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.457Z",devdoc:{details:"This contract documents the revert reasons used in the Exchange contract. This contract is intended to serve as a reference, but is not actually used for efficiency reasons.",methods:{}},userdoc:{methods:{}}};