"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.Rebalance={contractName:"Rebalance",abi:[],metadata:'{"compiler":{"version":"0.5.7+commit.6da8b019"},"language":"Solidity","output":{"abi":[],"devdoc":{"author":"Set Protocol * Types and functions for Rebalance-related data.","methods":{},"title":"Rebalance"},"userdoc":{"methods":{}}},"settings":{"compilationTarget":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/lib/Rebalance.sol":"Rebalance"},"evmVersion":"byzantium","libraries":{},"optimizer":{"enabled":true,"runs":200},"remappings":[]},"sources":{"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/interfaces/IRebalancingSetToken.sol":{"keccak256":"0xe7356a7b0f0cc95d9526395d776f523a48fd65618730d67b4f31f20ffbd380da","urls":["bzzr://605a33a818eff7ce3370f25fccb751f61c066b4db0772605a2215d1357d68072"]},"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/lib/Rebalance.sol":{"keccak256":"0x74ffa689d93ced6c6e0377a35ec1274241b6191b5aaac5576ada379ac3840286","urls":["bzzr://25bdda3f1f5adfa2c83c760c44993d250cd2df037360f0018d22d268df79e887"]},"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/lib/RebalancingLibrary.sol":{"keccak256":"0x7f9dd2f95b2ee71a98b94cb9b0df15874aa134e7480d04a1fcf36aff166a55f4","urls":["bzzr://f43a5563ec5df095151eee30cf7a0941b5a971917c27c7b34d9586b36563ab5b"]}},"version":1}',bytecode:"0x604c6023600b82828239805160001a607314601657fe5b30600052607381538281f3fe73000000000000000000000000000000000000000030146080604052600080fdfea165627a7a72305820aae6d38c7f73f766cde02ed9ab30592b3545e437cb5280f8977d638c121759f90029",deployedBytecode:"0x73000000000000000000000000000000000000000030146080604052600080fdfea165627a7a72305820aae6d38c7f73f766cde02ed9ab30592b3545e437cb5280f8977d638c121759f90029",sourceMap:"808:2046:43:-;;132:2:-1;166:7;155:9;146:7;137:37;255:7;249:14;246:1;241:23;235:4;232:33;222:2;;269:9;222:2;293:9;290:1;283:20;323:4;314:7;306:22;347:7;338;331:24",deployedSourceMap:"808:2046:43:-;;;;;;;;",source:'/*\n    Copyright 2019 Set Labs Inc.\n\n    Licensed under the Apache License, Version 2.0 (the "License");\n    you may not use this file except in compliance with the License.\n    You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\n    Unless required by applicable law or agreed to in writing, software\n    distributed under the License is distributed on an "AS IS" BASIS,\n    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n    See the License for the specific language governing permissions and\n    limitations under the License.\n*/\n\npragma solidity 0.5.7;\n\nimport { IRebalancingSetToken } from "../interfaces/IRebalancingSetToken.sol";\n\n\n/**\n * @title Rebalance\n * @author Set Protocol\n *\n * Types and functions for Rebalance-related data.\n */\nlibrary Rebalance {\n\n    struct TokenFlow {\n        address[] addresses;\n        uint256[] inflow;\n        uint256[] outflow;\n    }\n\n    function composeTokenFlow(\n        address[] memory _addresses,\n        uint256[] memory _inflow,\n        uint256[] memory _outflow\n    )\n        internal\n        pure\n        returns(TokenFlow memory)\n    {\n        return TokenFlow({addresses: _addresses, inflow: _inflow, outflow: _outflow });\n    }\n\n    function decomposeTokenFlow(TokenFlow memory _tokenFlow)\n        internal\n        pure\n        returns (address[] memory, uint256[] memory, uint256[] memory)\n    {\n        return (_tokenFlow.addresses, _tokenFlow.inflow, _tokenFlow.outflow);\n    }\n\n    function decomposeTokenFlowToBidPrice(TokenFlow memory _tokenFlow)\n        internal\n        pure\n        returns (uint256[] memory, uint256[] memory)\n    {\n        return (_tokenFlow.inflow, _tokenFlow.outflow);\n    }\n\n    /**\n     * Get token flows array of addresses, inflows and outflows\n     *\n     * @param    _rebalancingSetToken   The rebalancing Set Token instance\n     * @param    _quantity              The amount of currentSet to be rebalanced\n     * @return   combinedTokenArray     Array of token addresses\n     * @return   inflowArray            Array of amount of tokens inserted into system in bid\n     * @return   outflowArray           Array of amount of tokens returned from system in bid\n     */\n    function getTokenFlows(\n        IRebalancingSetToken _rebalancingSetToken,\n        uint256 _quantity\n    )\n        internal\n        view\n        returns (address[] memory, uint256[] memory, uint256[] memory)\n    {\n        // Get token addresses\n        address[] memory combinedTokenArray = _rebalancingSetToken.getCombinedTokenArray();\n\n        // Get inflow and outflow arrays for the given bid quantity\n        (\n            uint256[] memory inflowArray,\n            uint256[] memory outflowArray\n        ) = _rebalancingSetToken.getBidPrice(_quantity);\n\n        return (combinedTokenArray, inflowArray, outflowArray);\n    }\n}\n',sourcePath:"/Users/brianweickmann/Documents/Source/set-protocol-contracts/contracts/core/lib/Rebalance.sol",compiler:{name:"solc",version:"0.5.7+commit.6da8b019.Linux.g++"},networks:{},schemaVersion:"3.0.23",updatedAt:"2020-07-08T17:51:18.239Z",devdoc:{author:"Set Protocol * Types and functions for Rebalance-related data.",methods:{},title:"Rebalance"},userdoc:{methods:{}}};